# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['BalancerArgs', 'Balancer']

@pulumi.input_type
class BalancerArgs:
    def __init__(__self__, *,
                 datacenter_id: pulumi.Input[str],
                 nic_ids: pulumi.Input[Sequence[pulumi.Input[str]]],
                 dhcp: Optional[pulumi.Input[bool]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Balancer resource.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nic_ids: [list] A list of NIC IDs that are part of the load balancer.
        :param pulumi.Input[bool] dhcp: [Boolean] Indicates if the load balancer will reserve an IP using DHCP.
        :param pulumi.Input[str] ip: [string] IPv4 address of the load balancer.
        :param pulumi.Input[str] name: [string] The name of the load balancer.
        """
        pulumi.set(__self__, "datacenter_id", datacenter_id)
        pulumi.set(__self__, "nic_ids", nic_ids)
        if dhcp is not None:
            pulumi.set(__self__, "dhcp", dhcp)
        if ip is not None:
            pulumi.set(__self__, "ip", ip)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> pulumi.Input[str]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @datacenter_id.setter
    def datacenter_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "datacenter_id", value)

    @property
    @pulumi.getter(name="nicIds")
    def nic_ids(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        [list] A list of NIC IDs that are part of the load balancer.
        """
        return pulumi.get(self, "nic_ids")

    @nic_ids.setter
    def nic_ids(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "nic_ids", value)

    @property
    @pulumi.getter
    def dhcp(self) -> Optional[pulumi.Input[bool]]:
        """
        [Boolean] Indicates if the load balancer will reserve an IP using DHCP.
        """
        return pulumi.get(self, "dhcp")

    @dhcp.setter
    def dhcp(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dhcp", value)

    @property
    @pulumi.getter
    def ip(self) -> Optional[pulumi.Input[str]]:
        """
        [string] IPv4 address of the load balancer.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name of the load balancer.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _BalancerState:
    def __init__(__self__, *,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 dhcp: Optional[pulumi.Input[bool]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering Balancer resources.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[bool] dhcp: [Boolean] Indicates if the load balancer will reserve an IP using DHCP.
        :param pulumi.Input[str] ip: [string] IPv4 address of the load balancer.
        :param pulumi.Input[str] name: [string] The name of the load balancer.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nic_ids: [list] A list of NIC IDs that are part of the load balancer.
        """
        if datacenter_id is not None:
            pulumi.set(__self__, "datacenter_id", datacenter_id)
        if dhcp is not None:
            pulumi.set(__self__, "dhcp", dhcp)
        if ip is not None:
            pulumi.set(__self__, "ip", ip)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nic_ids is not None:
            pulumi.set(__self__, "nic_ids", nic_ids)

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @datacenter_id.setter
    def datacenter_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "datacenter_id", value)

    @property
    @pulumi.getter
    def dhcp(self) -> Optional[pulumi.Input[bool]]:
        """
        [Boolean] Indicates if the load balancer will reserve an IP using DHCP.
        """
        return pulumi.get(self, "dhcp")

    @dhcp.setter
    def dhcp(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "dhcp", value)

    @property
    @pulumi.getter
    def ip(self) -> Optional[pulumi.Input[str]]:
        """
        [string] IPv4 address of the load balancer.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name of the load balancer.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nicIds")
    def nic_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        [list] A list of NIC IDs that are part of the load balancer.
        """
        return pulumi.get(self, "nic_ids")

    @nic_ids.setter
    def nic_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "nic_ids", value)


class Balancer(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 dhcp: Optional[pulumi.Input[bool]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Manages a Load Balancer on IonosCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="us/las",
            description="Datacenter Description",
            sec_auth_protection=False)
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=True,
            name="Lan Example")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_server = ionoscloud.compute.Server("example",
            name="Server Example",
            datacenter_id=example.id,
            cores=1,
            ram=1024,
            availability_zone="ZONE_1",
            cpu_family="INTEL_XEON",
            image_name="Ubuntu-20.04",
            image_password=server_image_password["result"],
            volume={
                "name": "system",
                "size": 14,
                "disk_type": "SSD",
            },
            nic={
                "lan": 1,
                "dhcp": True,
                "firewall_active": True,
            })
        example_balancer = ionoscloud.compute.Balancer("example",
            datacenter_id=example.id,
            nic_ids=[example_server.primary_nic],
            name="Load Balancer Example",
            dhcp=True)
        ```

        ## A note on nics

        When declaring NIC resources to be used with the load balancer, please make sure
        you use the "lifecycle meta-argument" to make sure changes to the lan attribute
        of the nic are ignored.

        Please see the Nic resource's documentation for an example on how to do that.

        ## Import

        Resource Load Balancer can be imported using the `resource id`, e.g.

        ```sh
        $ pulumi import ionoscloud:compute/balancer:Balancer myloadbalancer datacenter uuid/loadbalancer uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[bool] dhcp: [Boolean] Indicates if the load balancer will reserve an IP using DHCP.
        :param pulumi.Input[str] ip: [string] IPv4 address of the load balancer.
        :param pulumi.Input[str] name: [string] The name of the load balancer.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nic_ids: [list] A list of NIC IDs that are part of the load balancer.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BalancerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a Load Balancer on IonosCloud.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="us/las",
            description="Datacenter Description",
            sec_auth_protection=False)
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=True,
            name="Lan Example")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_server = ionoscloud.compute.Server("example",
            name="Server Example",
            datacenter_id=example.id,
            cores=1,
            ram=1024,
            availability_zone="ZONE_1",
            cpu_family="INTEL_XEON",
            image_name="Ubuntu-20.04",
            image_password=server_image_password["result"],
            volume={
                "name": "system",
                "size": 14,
                "disk_type": "SSD",
            },
            nic={
                "lan": 1,
                "dhcp": True,
                "firewall_active": True,
            })
        example_balancer = ionoscloud.compute.Balancer("example",
            datacenter_id=example.id,
            nic_ids=[example_server.primary_nic],
            name="Load Balancer Example",
            dhcp=True)
        ```

        ## A note on nics

        When declaring NIC resources to be used with the load balancer, please make sure
        you use the "lifecycle meta-argument" to make sure changes to the lan attribute
        of the nic are ignored.

        Please see the Nic resource's documentation for an example on how to do that.

        ## Import

        Resource Load Balancer can be imported using the `resource id`, e.g.

        ```sh
        $ pulumi import ionoscloud:compute/balancer:Balancer myloadbalancer datacenter uuid/loadbalancer uuid
        ```

        :param str resource_name: The name of the resource.
        :param BalancerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BalancerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 dhcp: Optional[pulumi.Input[bool]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BalancerArgs.__new__(BalancerArgs)

            if datacenter_id is None and not opts.urn:
                raise TypeError("Missing required property 'datacenter_id'")
            __props__.__dict__["datacenter_id"] = datacenter_id
            __props__.__dict__["dhcp"] = dhcp
            __props__.__dict__["ip"] = ip
            __props__.__dict__["name"] = name
            if nic_ids is None and not opts.urn:
                raise TypeError("Missing required property 'nic_ids'")
            __props__.__dict__["nic_ids"] = nic_ids
        super(Balancer, __self__).__init__(
            'ionoscloud:compute/balancer:Balancer',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            datacenter_id: Optional[pulumi.Input[str]] = None,
            dhcp: Optional[pulumi.Input[bool]] = None,
            ip: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            nic_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'Balancer':
        """
        Get an existing Balancer resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[bool] dhcp: [Boolean] Indicates if the load balancer will reserve an IP using DHCP.
        :param pulumi.Input[str] ip: [string] IPv4 address of the load balancer.
        :param pulumi.Input[str] name: [string] The name of the load balancer.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] nic_ids: [list] A list of NIC IDs that are part of the load balancer.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BalancerState.__new__(_BalancerState)

        __props__.__dict__["datacenter_id"] = datacenter_id
        __props__.__dict__["dhcp"] = dhcp
        __props__.__dict__["ip"] = ip
        __props__.__dict__["name"] = name
        __props__.__dict__["nic_ids"] = nic_ids
        return Balancer(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> pulumi.Output[str]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @property
    @pulumi.getter
    def dhcp(self) -> pulumi.Output[Optional[bool]]:
        """
        [Boolean] Indicates if the load balancer will reserve an IP using DHCP.
        """
        return pulumi.get(self, "dhcp")

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Output[str]:
        """
        [string] IPv4 address of the load balancer.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        [string] The name of the load balancer.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nicIds")
    def nic_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        [list] A list of NIC IDs that are part of the load balancer.
        """
        return pulumi.get(self, "nic_ids")

