# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['CubeServerArgs', 'CubeServer']

@pulumi.input_type
class CubeServerArgs:
    def __init__(__self__, *,
                 datacenter_id: pulumi.Input[str],
                 nic: pulumi.Input['CubeServerNicArgs'],
                 template_uuid: pulumi.Input[str],
                 volume: pulumi.Input['CubeServerVolumeArgs'],
                 allow_replace: Optional[pulumi.Input[bool]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_paths: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a CubeServer resource.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input['CubeServerNicArgs'] nic: See the Nic section.
        :param pulumi.Input[str] template_uuid: [string] The UUID of the template for creating a CUBE server; the available templates for CUBE servers can be found on the templates resource
        :param pulumi.Input['CubeServerVolumeArgs'] volume: See the Volume section.
        :param pulumi.Input[bool] allow_replace: [bool] When set to true, allows the update of immutable fields by first destroying and then re-creating the server.
               
               ⚠️ **_Warning: `allow_replace` - lets you update immutable fields, but it first destroys and then re-creates the server in order to do it. This field should be used with care, understanding the risks._**
               
               > **⚠ WARNING**
               >
               > Image_name under volume level is deprecated, please use image_name under server level
               
               
               > **⚠ WARNING**
               >
               > For creating a **CUBE** server, you can not set `volume.size` argument.
               >
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[str] hostname: (Computed) The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] Required if `ssh_key_path` is not provided.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_paths: [list] List of paths to files containing a public SSH key that will be injected into IonosCloud provided Linux images. Required for IonosCloud Linux images. Required if `image_password` is not provided.
        :param pulumi.Input[str] vm_state: [string] Sets the power state of the cube server. E.g: `RUNNING` or `SUSPENDED`.
        """
        pulumi.set(__self__, "datacenter_id", datacenter_id)
        pulumi.set(__self__, "nic", nic)
        pulumi.set(__self__, "template_uuid", template_uuid)
        pulumi.set(__self__, "volume", volume)
        if allow_replace is not None:
            pulumi.set(__self__, "allow_replace", allow_replace)
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if boot_cdrom is not None:
            warnings.warn("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""", DeprecationWarning)
            pulumi.log.warn("""boot_cdrom is deprecated: Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
        if boot_cdrom is not None:
            pulumi.set(__self__, "boot_cdrom", boot_cdrom)
        if boot_image is not None:
            pulumi.set(__self__, "boot_image", boot_image)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if image_name is not None:
            pulumi.set(__self__, "image_name", image_name)
        if image_password is not None:
            pulumi.set(__self__, "image_password", image_password)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if security_groups_ids is not None:
            pulumi.set(__self__, "security_groups_ids", security_groups_ids)
        if ssh_key_paths is not None:
            pulumi.set(__self__, "ssh_key_paths", ssh_key_paths)
        if vm_state is not None:
            pulumi.set(__self__, "vm_state", vm_state)

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> pulumi.Input[str]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @datacenter_id.setter
    def datacenter_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "datacenter_id", value)

    @property
    @pulumi.getter
    def nic(self) -> pulumi.Input['CubeServerNicArgs']:
        """
        See the Nic section.
        """
        return pulumi.get(self, "nic")

    @nic.setter
    def nic(self, value: pulumi.Input['CubeServerNicArgs']):
        pulumi.set(self, "nic", value)

    @property
    @pulumi.getter(name="templateUuid")
    def template_uuid(self) -> pulumi.Input[str]:
        """
        [string] The UUID of the template for creating a CUBE server; the available templates for CUBE servers can be found on the templates resource
        """
        return pulumi.get(self, "template_uuid")

    @template_uuid.setter
    def template_uuid(self, value: pulumi.Input[str]):
        pulumi.set(self, "template_uuid", value)

    @property
    @pulumi.getter
    def volume(self) -> pulumi.Input['CubeServerVolumeArgs']:
        """
        See the Volume section.
        """
        return pulumi.get(self, "volume")

    @volume.setter
    def volume(self, value: pulumi.Input['CubeServerVolumeArgs']):
        pulumi.set(self, "volume", value)

    @property
    @pulumi.getter(name="allowReplace")
    def allow_replace(self) -> Optional[pulumi.Input[bool]]:
        """
        [bool] When set to true, allows the update of immutable fields by first destroying and then re-creating the server.

        ⚠️ **_Warning: `allow_replace` - lets you update immutable fields, but it first destroys and then re-creates the server in order to do it. This field should be used with care, understanding the risks._**

        > **⚠ WARNING**
        >
        > Image_name under volume level is deprecated, please use image_name under server level


        > **⚠ WARNING**
        >
        > For creating a **CUBE** server, you can not set `volume.size` argument.
        >
        """
        return pulumi.get(self, "allow_replace")

    @allow_replace.setter
    def allow_replace(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_replace", value)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The availability zone in which the server should exist. This property is immutable.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter(name="bootCdrom")
    @_utilities.deprecated("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
    def boot_cdrom(self) -> Optional[pulumi.Input[str]]:
        """
        ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        """
        return pulumi.get(self, "boot_cdrom")

    @boot_cdrom.setter
    def boot_cdrom(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_cdrom", value)

    @property
    @pulumi.getter(name="bootImage")
    def boot_image(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        """
        return pulumi.get(self, "boot_image")

    @boot_image.setter
    def boot_image(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_image", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed) The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        """
        return pulumi.get(self, "image_name")

    @image_name.setter
    def image_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_name", value)

    @property
    @pulumi.getter(name="imagePassword")
    def image_password(self) -> Optional[pulumi.Input[str]]:
        """
        [string] Required if `ssh_key_path` is not provided.
        """
        return pulumi.get(self, "image_password")

    @image_password.setter
    def image_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_password", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name of the server.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="securityGroupsIds")
    def security_groups_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of Security Group IDs for the resource.
        """
        return pulumi.get(self, "security_groups_ids")

    @security_groups_ids.setter
    def security_groups_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups_ids", value)

    @property
    @pulumi.getter(name="sshKeyPaths")
    def ssh_key_paths(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        [list] List of paths to files containing a public SSH key that will be injected into IonosCloud provided Linux images. Required for IonosCloud Linux images. Required if `image_password` is not provided.
        """
        return pulumi.get(self, "ssh_key_paths")

    @ssh_key_paths.setter
    def ssh_key_paths(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ssh_key_paths", value)

    @property
    @pulumi.getter(name="vmState")
    def vm_state(self) -> Optional[pulumi.Input[str]]:
        """
        [string] Sets the power state of the cube server. E.g: `RUNNING` or `SUSPENDED`.
        """
        return pulumi.get(self, "vm_state")

    @vm_state.setter
    def vm_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_state", value)


@pulumi.input_type
class _CubeServerState:
    def __init__(__self__, *,
                 allow_replace: Optional[pulumi.Input[bool]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 boot_volume: Optional[pulumi.Input[str]] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 firewallrule_id: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 inline_volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic: Optional[pulumi.Input['CubeServerNicArgs']] = None,
                 primary_ip: Optional[pulumi.Input[str]] = None,
                 primary_nic: Optional[pulumi.Input[str]] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_paths: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 template_uuid: Optional[pulumi.Input[str]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None,
                 volume: Optional[pulumi.Input['CubeServerVolumeArgs']] = None):
        """
        Input properties used for looking up and filtering CubeServer resources.
        :param pulumi.Input[bool] allow_replace: [bool] When set to true, allows the update of immutable fields by first destroying and then re-creating the server.
               
               ⚠️ **_Warning: `allow_replace` - lets you update immutable fields, but it first destroys and then re-creates the server in order to do it. This field should be used with care, understanding the risks._**
               
               > **⚠ WARNING**
               >
               > Image_name under volume level is deprecated, please use image_name under server level
               
               
               > **⚠ WARNING**
               >
               > For creating a **CUBE** server, you can not set `volume.size` argument.
               >
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[str] boot_volume: The associated boot volume.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[str] firewallrule_id: The associated firewall rule.
        :param pulumi.Input[str] hostname: (Computed) The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] Required if `ssh_key_path` is not provided.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] inline_volume_ids: A list that contains the IDs for the volumes defined inside the cube server resource.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input['CubeServerNicArgs'] nic: See the Nic section.
        :param pulumi.Input[str] primary_ip: The associated IP address.
        :param pulumi.Input[str] primary_nic: The associated NIC.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_paths: [list] List of paths to files containing a public SSH key that will be injected into IonosCloud provided Linux images. Required for IonosCloud Linux images. Required if `image_password` is not provided.
        :param pulumi.Input[str] template_uuid: [string] The UUID of the template for creating a CUBE server; the available templates for CUBE servers can be found on the templates resource
        :param pulumi.Input[str] vm_state: [string] Sets the power state of the cube server. E.g: `RUNNING` or `SUSPENDED`.
        :param pulumi.Input['CubeServerVolumeArgs'] volume: See the Volume section.
        """
        if allow_replace is not None:
            pulumi.set(__self__, "allow_replace", allow_replace)
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if boot_cdrom is not None:
            warnings.warn("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""", DeprecationWarning)
            pulumi.log.warn("""boot_cdrom is deprecated: Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
        if boot_cdrom is not None:
            pulumi.set(__self__, "boot_cdrom", boot_cdrom)
        if boot_image is not None:
            pulumi.set(__self__, "boot_image", boot_image)
        if boot_volume is not None:
            pulumi.set(__self__, "boot_volume", boot_volume)
        if datacenter_id is not None:
            pulumi.set(__self__, "datacenter_id", datacenter_id)
        if firewallrule_id is not None:
            pulumi.set(__self__, "firewallrule_id", firewallrule_id)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if image_name is not None:
            pulumi.set(__self__, "image_name", image_name)
        if image_password is not None:
            pulumi.set(__self__, "image_password", image_password)
        if inline_volume_ids is not None:
            pulumi.set(__self__, "inline_volume_ids", inline_volume_ids)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nic is not None:
            pulumi.set(__self__, "nic", nic)
        if primary_ip is not None:
            pulumi.set(__self__, "primary_ip", primary_ip)
        if primary_nic is not None:
            pulumi.set(__self__, "primary_nic", primary_nic)
        if security_groups_ids is not None:
            pulumi.set(__self__, "security_groups_ids", security_groups_ids)
        if ssh_key_paths is not None:
            pulumi.set(__self__, "ssh_key_paths", ssh_key_paths)
        if template_uuid is not None:
            pulumi.set(__self__, "template_uuid", template_uuid)
        if vm_state is not None:
            pulumi.set(__self__, "vm_state", vm_state)
        if volume is not None:
            pulumi.set(__self__, "volume", volume)

    @property
    @pulumi.getter(name="allowReplace")
    def allow_replace(self) -> Optional[pulumi.Input[bool]]:
        """
        [bool] When set to true, allows the update of immutable fields by first destroying and then re-creating the server.

        ⚠️ **_Warning: `allow_replace` - lets you update immutable fields, but it first destroys and then re-creates the server in order to do it. This field should be used with care, understanding the risks._**

        > **⚠ WARNING**
        >
        > Image_name under volume level is deprecated, please use image_name under server level


        > **⚠ WARNING**
        >
        > For creating a **CUBE** server, you can not set `volume.size` argument.
        >
        """
        return pulumi.get(self, "allow_replace")

    @allow_replace.setter
    def allow_replace(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_replace", value)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The availability zone in which the server should exist. This property is immutable.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter(name="bootCdrom")
    @_utilities.deprecated("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
    def boot_cdrom(self) -> Optional[pulumi.Input[str]]:
        """
        ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        """
        return pulumi.get(self, "boot_cdrom")

    @boot_cdrom.setter
    def boot_cdrom(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_cdrom", value)

    @property
    @pulumi.getter(name="bootImage")
    def boot_image(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        """
        return pulumi.get(self, "boot_image")

    @boot_image.setter
    def boot_image(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_image", value)

    @property
    @pulumi.getter(name="bootVolume")
    def boot_volume(self) -> Optional[pulumi.Input[str]]:
        """
        The associated boot volume.
        """
        return pulumi.get(self, "boot_volume")

    @boot_volume.setter
    def boot_volume(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_volume", value)

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @datacenter_id.setter
    def datacenter_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "datacenter_id", value)

    @property
    @pulumi.getter(name="firewallruleId")
    def firewallrule_id(self) -> Optional[pulumi.Input[str]]:
        """
        The associated firewall rule.
        """
        return pulumi.get(self, "firewallrule_id")

    @firewallrule_id.setter
    def firewallrule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "firewallrule_id", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed) The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        """
        return pulumi.get(self, "image_name")

    @image_name.setter
    def image_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_name", value)

    @property
    @pulumi.getter(name="imagePassword")
    def image_password(self) -> Optional[pulumi.Input[str]]:
        """
        [string] Required if `ssh_key_path` is not provided.
        """
        return pulumi.get(self, "image_password")

    @image_password.setter
    def image_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_password", value)

    @property
    @pulumi.getter(name="inlineVolumeIds")
    def inline_volume_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list that contains the IDs for the volumes defined inside the cube server resource.
        """
        return pulumi.get(self, "inline_volume_ids")

    @inline_volume_ids.setter
    def inline_volume_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "inline_volume_ids", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name of the server.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def nic(self) -> Optional[pulumi.Input['CubeServerNicArgs']]:
        """
        See the Nic section.
        """
        return pulumi.get(self, "nic")

    @nic.setter
    def nic(self, value: Optional[pulumi.Input['CubeServerNicArgs']]):
        pulumi.set(self, "nic", value)

    @property
    @pulumi.getter(name="primaryIp")
    def primary_ip(self) -> Optional[pulumi.Input[str]]:
        """
        The associated IP address.
        """
        return pulumi.get(self, "primary_ip")

    @primary_ip.setter
    def primary_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_ip", value)

    @property
    @pulumi.getter(name="primaryNic")
    def primary_nic(self) -> Optional[pulumi.Input[str]]:
        """
        The associated NIC.
        """
        return pulumi.get(self, "primary_nic")

    @primary_nic.setter
    def primary_nic(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_nic", value)

    @property
    @pulumi.getter(name="securityGroupsIds")
    def security_groups_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of Security Group IDs for the resource.
        """
        return pulumi.get(self, "security_groups_ids")

    @security_groups_ids.setter
    def security_groups_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups_ids", value)

    @property
    @pulumi.getter(name="sshKeyPaths")
    def ssh_key_paths(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        [list] List of paths to files containing a public SSH key that will be injected into IonosCloud provided Linux images. Required for IonosCloud Linux images. Required if `image_password` is not provided.
        """
        return pulumi.get(self, "ssh_key_paths")

    @ssh_key_paths.setter
    def ssh_key_paths(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ssh_key_paths", value)

    @property
    @pulumi.getter(name="templateUuid")
    def template_uuid(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The UUID of the template for creating a CUBE server; the available templates for CUBE servers can be found on the templates resource
        """
        return pulumi.get(self, "template_uuid")

    @template_uuid.setter
    def template_uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "template_uuid", value)

    @property
    @pulumi.getter(name="vmState")
    def vm_state(self) -> Optional[pulumi.Input[str]]:
        """
        [string] Sets the power state of the cube server. E.g: `RUNNING` or `SUSPENDED`.
        """
        return pulumi.get(self, "vm_state")

    @vm_state.setter
    def vm_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_state", value)

    @property
    @pulumi.getter
    def volume(self) -> Optional[pulumi.Input['CubeServerVolumeArgs']]:
        """
        See the Volume section.
        """
        return pulumi.get(self, "volume")

    @volume.setter
    def volume(self, value: Optional[pulumi.Input['CubeServerVolumeArgs']]):
        pulumi.set(self, "volume", value)


class CubeServer(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_replace: Optional[pulumi.Input[bool]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic: Optional[pulumi.Input[Union['CubeServerNicArgs', 'CubeServerNicArgsDict']]] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_paths: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 template_uuid: Optional[pulumi.Input[str]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None,
                 volume: Optional[pulumi.Input[Union['CubeServerVolumeArgs', 'CubeServerVolumeArgsDict']]] = None,
                 __props__=None):
        """
        Manages a **Cube Server** on IonosCloud.

        ## Example Usage

        This resource will create an operational server. After this section completes, the provisioner can be called.

        ### CUBE Server

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.get_template(name="Basic Cube XS")
        example_datacenter = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="de/txl")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example_datacenter.id,
            public=True,
            name="Lan Example")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_cube_server = ionoscloud.compute.CubeServer("example",
            name="Server Example",
            availability_zone="ZONE_2",
            image_name="ubuntu:latest",
            template_uuid=example.id,
            image_password=server_image_password["result"],
            datacenter_id=example_datacenter.id,
            volume={
                "name": "Volume Example",
                "licence_type": "LINUX",
                "disk_type": "DAS",
            },
            nic={
                "lan": example_lan.id,
                "name": "Nic Example",
                "dhcp": True,
                "firewall_active": True,
            })
        ```

        ### With IPv6 Enabled

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.get_template(name="Basic Cube XS")
        example_datacenter = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="de/txl")
        webserver_ipblock = ionoscloud.compute.IPBlock("webserver_ipblock",
            location="de/txl",
            size=4,
            name="webserver_ipblock")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example_datacenter.id,
            public=True,
            name="Lan Example",
            ipv6_cidr_block="ipv6_cidr_block_from_dc")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_cube_server = ionoscloud.compute.CubeServer("example",
            name="Server Example",
            availability_zone="AUTO",
            image_name="ubuntu:latest",
            template_uuid=example.id,
            image_password=server_image_password["result"],
            datacenter_id=example_datacenter.id,
            volume={
                "name": "Volume Example",
                "licence_type": "LINUX",
                "disk_type": "DAS",
            },
            nic={
                "lan": example_lan.id,
                "name": "Nic Example",
                "dhcp": True,
                "ips": [
                    webserver_ipblock.ips[0],
                    webserver_ipblock.ips[1],
                ],
                "dhcpv6": False,
                "ipv6_cidr_block": "ipv6_cidr_block_from_lan",
                "ipv6_ips": [
                    "ipv6_ip1",
                    "ipv6_ip2",
                    "ipv6_ip3",
                ],
                "firewall_active": True,
            })
        ```

        ## Notes

        Please note that for any secondary volume, you need to set the **licence_type** property to **UNKNOWN**

        ## Import

        Resource Server can be imported using the `resource id` and the `datacenter id`, e.g.

        ```sh
        $ pulumi import ionoscloud:compute/cubeServer:CubeServer myserver datacenter uuid/server uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] allow_replace: [bool] When set to true, allows the update of immutable fields by first destroying and then re-creating the server.
               
               ⚠️ **_Warning: `allow_replace` - lets you update immutable fields, but it first destroys and then re-creates the server in order to do it. This field should be used with care, understanding the risks._**
               
               > **⚠ WARNING**
               >
               > Image_name under volume level is deprecated, please use image_name under server level
               
               
               > **⚠ WARNING**
               >
               > For creating a **CUBE** server, you can not set `volume.size` argument.
               >
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[str] hostname: (Computed) The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] Required if `ssh_key_path` is not provided.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input[Union['CubeServerNicArgs', 'CubeServerNicArgsDict']] nic: See the Nic section.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_paths: [list] List of paths to files containing a public SSH key that will be injected into IonosCloud provided Linux images. Required for IonosCloud Linux images. Required if `image_password` is not provided.
        :param pulumi.Input[str] template_uuid: [string] The UUID of the template for creating a CUBE server; the available templates for CUBE servers can be found on the templates resource
        :param pulumi.Input[str] vm_state: [string] Sets the power state of the cube server. E.g: `RUNNING` or `SUSPENDED`.
        :param pulumi.Input[Union['CubeServerVolumeArgs', 'CubeServerVolumeArgsDict']] volume: See the Volume section.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CubeServerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a **Cube Server** on IonosCloud.

        ## Example Usage

        This resource will create an operational server. After this section completes, the provisioner can be called.

        ### CUBE Server

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.get_template(name="Basic Cube XS")
        example_datacenter = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="de/txl")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example_datacenter.id,
            public=True,
            name="Lan Example")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_cube_server = ionoscloud.compute.CubeServer("example",
            name="Server Example",
            availability_zone="ZONE_2",
            image_name="ubuntu:latest",
            template_uuid=example.id,
            image_password=server_image_password["result"],
            datacenter_id=example_datacenter.id,
            volume={
                "name": "Volume Example",
                "licence_type": "LINUX",
                "disk_type": "DAS",
            },
            nic={
                "lan": example_lan.id,
                "name": "Nic Example",
                "dhcp": True,
                "firewall_active": True,
            })
        ```

        ### With IPv6 Enabled

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.get_template(name="Basic Cube XS")
        example_datacenter = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="de/txl")
        webserver_ipblock = ionoscloud.compute.IPBlock("webserver_ipblock",
            location="de/txl",
            size=4,
            name="webserver_ipblock")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example_datacenter.id,
            public=True,
            name="Lan Example",
            ipv6_cidr_block="ipv6_cidr_block_from_dc")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_cube_server = ionoscloud.compute.CubeServer("example",
            name="Server Example",
            availability_zone="AUTO",
            image_name="ubuntu:latest",
            template_uuid=example.id,
            image_password=server_image_password["result"],
            datacenter_id=example_datacenter.id,
            volume={
                "name": "Volume Example",
                "licence_type": "LINUX",
                "disk_type": "DAS",
            },
            nic={
                "lan": example_lan.id,
                "name": "Nic Example",
                "dhcp": True,
                "ips": [
                    webserver_ipblock.ips[0],
                    webserver_ipblock.ips[1],
                ],
                "dhcpv6": False,
                "ipv6_cidr_block": "ipv6_cidr_block_from_lan",
                "ipv6_ips": [
                    "ipv6_ip1",
                    "ipv6_ip2",
                    "ipv6_ip3",
                ],
                "firewall_active": True,
            })
        ```

        ## Notes

        Please note that for any secondary volume, you need to set the **licence_type** property to **UNKNOWN**

        ## Import

        Resource Server can be imported using the `resource id` and the `datacenter id`, e.g.

        ```sh
        $ pulumi import ionoscloud:compute/cubeServer:CubeServer myserver datacenter uuid/server uuid
        ```

        :param str resource_name: The name of the resource.
        :param CubeServerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CubeServerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_replace: Optional[pulumi.Input[bool]] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic: Optional[pulumi.Input[Union['CubeServerNicArgs', 'CubeServerNicArgsDict']]] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_key_paths: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 template_uuid: Optional[pulumi.Input[str]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None,
                 volume: Optional[pulumi.Input[Union['CubeServerVolumeArgs', 'CubeServerVolumeArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CubeServerArgs.__new__(CubeServerArgs)

            __props__.__dict__["allow_replace"] = allow_replace
            __props__.__dict__["availability_zone"] = availability_zone
            __props__.__dict__["boot_cdrom"] = boot_cdrom
            __props__.__dict__["boot_image"] = boot_image
            if datacenter_id is None and not opts.urn:
                raise TypeError("Missing required property 'datacenter_id'")
            __props__.__dict__["datacenter_id"] = datacenter_id
            __props__.__dict__["hostname"] = hostname
            __props__.__dict__["image_name"] = image_name
            __props__.__dict__["image_password"] = None if image_password is None else pulumi.Output.secret(image_password)
            __props__.__dict__["name"] = name
            if nic is None and not opts.urn:
                raise TypeError("Missing required property 'nic'")
            __props__.__dict__["nic"] = nic
            __props__.__dict__["security_groups_ids"] = security_groups_ids
            __props__.__dict__["ssh_key_paths"] = ssh_key_paths
            if template_uuid is None and not opts.urn:
                raise TypeError("Missing required property 'template_uuid'")
            __props__.__dict__["template_uuid"] = template_uuid
            __props__.__dict__["vm_state"] = vm_state
            if volume is None and not opts.urn:
                raise TypeError("Missing required property 'volume'")
            __props__.__dict__["volume"] = volume
            __props__.__dict__["boot_volume"] = None
            __props__.__dict__["firewallrule_id"] = None
            __props__.__dict__["inline_volume_ids"] = None
            __props__.__dict__["primary_ip"] = None
            __props__.__dict__["primary_nic"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["imagePassword"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(CubeServer, __self__).__init__(
            'ionoscloud:compute/cubeServer:CubeServer',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            allow_replace: Optional[pulumi.Input[bool]] = None,
            availability_zone: Optional[pulumi.Input[str]] = None,
            boot_cdrom: Optional[pulumi.Input[str]] = None,
            boot_image: Optional[pulumi.Input[str]] = None,
            boot_volume: Optional[pulumi.Input[str]] = None,
            datacenter_id: Optional[pulumi.Input[str]] = None,
            firewallrule_id: Optional[pulumi.Input[str]] = None,
            hostname: Optional[pulumi.Input[str]] = None,
            image_name: Optional[pulumi.Input[str]] = None,
            image_password: Optional[pulumi.Input[str]] = None,
            inline_volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            nic: Optional[pulumi.Input[Union['CubeServerNicArgs', 'CubeServerNicArgsDict']]] = None,
            primary_ip: Optional[pulumi.Input[str]] = None,
            primary_nic: Optional[pulumi.Input[str]] = None,
            security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            ssh_key_paths: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            template_uuid: Optional[pulumi.Input[str]] = None,
            vm_state: Optional[pulumi.Input[str]] = None,
            volume: Optional[pulumi.Input[Union['CubeServerVolumeArgs', 'CubeServerVolumeArgsDict']]] = None) -> 'CubeServer':
        """
        Get an existing CubeServer resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] allow_replace: [bool] When set to true, allows the update of immutable fields by first destroying and then re-creating the server.
               
               ⚠️ **_Warning: `allow_replace` - lets you update immutable fields, but it first destroys and then re-creates the server in order to do it. This field should be used with care, understanding the risks._**
               
               > **⚠ WARNING**
               >
               > Image_name under volume level is deprecated, please use image_name under server level
               
               
               > **⚠ WARNING**
               >
               > For creating a **CUBE** server, you can not set `volume.size` argument.
               >
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[str] boot_volume: The associated boot volume.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[str] firewallrule_id: The associated firewall rule.
        :param pulumi.Input[str] hostname: (Computed) The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] Required if `ssh_key_path` is not provided.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] inline_volume_ids: A list that contains the IDs for the volumes defined inside the cube server resource.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input[Union['CubeServerNicArgs', 'CubeServerNicArgsDict']] nic: See the Nic section.
        :param pulumi.Input[str] primary_ip: The associated IP address.
        :param pulumi.Input[str] primary_nic: The associated NIC.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_key_paths: [list] List of paths to files containing a public SSH key that will be injected into IonosCloud provided Linux images. Required for IonosCloud Linux images. Required if `image_password` is not provided.
        :param pulumi.Input[str] template_uuid: [string] The UUID of the template for creating a CUBE server; the available templates for CUBE servers can be found on the templates resource
        :param pulumi.Input[str] vm_state: [string] Sets the power state of the cube server. E.g: `RUNNING` or `SUSPENDED`.
        :param pulumi.Input[Union['CubeServerVolumeArgs', 'CubeServerVolumeArgsDict']] volume: See the Volume section.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CubeServerState.__new__(_CubeServerState)

        __props__.__dict__["allow_replace"] = allow_replace
        __props__.__dict__["availability_zone"] = availability_zone
        __props__.__dict__["boot_cdrom"] = boot_cdrom
        __props__.__dict__["boot_image"] = boot_image
        __props__.__dict__["boot_volume"] = boot_volume
        __props__.__dict__["datacenter_id"] = datacenter_id
        __props__.__dict__["firewallrule_id"] = firewallrule_id
        __props__.__dict__["hostname"] = hostname
        __props__.__dict__["image_name"] = image_name
        __props__.__dict__["image_password"] = image_password
        __props__.__dict__["inline_volume_ids"] = inline_volume_ids
        __props__.__dict__["name"] = name
        __props__.__dict__["nic"] = nic
        __props__.__dict__["primary_ip"] = primary_ip
        __props__.__dict__["primary_nic"] = primary_nic
        __props__.__dict__["security_groups_ids"] = security_groups_ids
        __props__.__dict__["ssh_key_paths"] = ssh_key_paths
        __props__.__dict__["template_uuid"] = template_uuid
        __props__.__dict__["vm_state"] = vm_state
        __props__.__dict__["volume"] = volume
        return CubeServer(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="allowReplace")
    def allow_replace(self) -> pulumi.Output[Optional[bool]]:
        """
        [bool] When set to true, allows the update of immutable fields by first destroying and then re-creating the server.

        ⚠️ **_Warning: `allow_replace` - lets you update immutable fields, but it first destroys and then re-creates the server in order to do it. This field should be used with care, understanding the risks._**

        > **⚠ WARNING**
        >
        > Image_name under volume level is deprecated, please use image_name under server level


        > **⚠ WARNING**
        >
        > For creating a **CUBE** server, you can not set `volume.size` argument.
        >
        """
        return pulumi.get(self, "allow_replace")

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> pulumi.Output[str]:
        """
        [string] The availability zone in which the server should exist. This property is immutable.
        """
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter(name="bootCdrom")
    @_utilities.deprecated("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
    def boot_cdrom(self) -> pulumi.Output[str]:
        """
        ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        """
        return pulumi.get(self, "boot_cdrom")

    @property
    @pulumi.getter(name="bootImage")
    def boot_image(self) -> pulumi.Output[str]:
        """
        [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        """
        return pulumi.get(self, "boot_image")

    @property
    @pulumi.getter(name="bootVolume")
    def boot_volume(self) -> pulumi.Output[str]:
        """
        The associated boot volume.
        """
        return pulumi.get(self, "boot_volume")

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> pulumi.Output[str]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @property
    @pulumi.getter(name="firewallruleId")
    def firewallrule_id(self) -> pulumi.Output[str]:
        """
        The associated firewall rule.
        """
        return pulumi.get(self, "firewallrule_id")

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Output[str]:
        """
        (Computed) The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> pulumi.Output[str]:
        """
        [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        """
        return pulumi.get(self, "image_name")

    @property
    @pulumi.getter(name="imagePassword")
    def image_password(self) -> pulumi.Output[str]:
        """
        [string] Required if `ssh_key_path` is not provided.
        """
        return pulumi.get(self, "image_password")

    @property
    @pulumi.getter(name="inlineVolumeIds")
    def inline_volume_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        A list that contains the IDs for the volumes defined inside the cube server resource.
        """
        return pulumi.get(self, "inline_volume_ids")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        [string] The name of the server.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def nic(self) -> pulumi.Output['outputs.CubeServerNic']:
        """
        See the Nic section.
        """
        return pulumi.get(self, "nic")

    @property
    @pulumi.getter(name="primaryIp")
    def primary_ip(self) -> pulumi.Output[str]:
        """
        The associated IP address.
        """
        return pulumi.get(self, "primary_ip")

    @property
    @pulumi.getter(name="primaryNic")
    def primary_nic(self) -> pulumi.Output[str]:
        """
        The associated NIC.
        """
        return pulumi.get(self, "primary_nic")

    @property
    @pulumi.getter(name="securityGroupsIds")
    def security_groups_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The list of Security Group IDs for the resource.
        """
        return pulumi.get(self, "security_groups_ids")

    @property
    @pulumi.getter(name="sshKeyPaths")
    def ssh_key_paths(self) -> pulumi.Output[Sequence[str]]:
        """
        [list] List of paths to files containing a public SSH key that will be injected into IonosCloud provided Linux images. Required for IonosCloud Linux images. Required if `image_password` is not provided.
        """
        return pulumi.get(self, "ssh_key_paths")

    @property
    @pulumi.getter(name="templateUuid")
    def template_uuid(self) -> pulumi.Output[str]:
        """
        [string] The UUID of the template for creating a CUBE server; the available templates for CUBE servers can be found on the templates resource
        """
        return pulumi.get(self, "template_uuid")

    @property
    @pulumi.getter(name="vmState")
    def vm_state(self) -> pulumi.Output[str]:
        """
        [string] Sets the power state of the cube server. E.g: `RUNNING` or `SUSPENDED`.
        """
        return pulumi.get(self, "vm_state")

    @property
    @pulumi.getter
    def volume(self) -> pulumi.Output['outputs.CubeServerVolume']:
        """
        See the Volume section.
        """
        return pulumi.get(self, "volume")

