# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['VCPUServerArgs', 'VCPUServer']

@pulumi.input_type
class VCPUServerArgs:
    def __init__(__self__, *,
                 cores: pulumi.Input[int],
                 datacenter_id: pulumi.Input[str],
                 ram: pulumi.Input[int],
                 volume: pulumi.Input['VCPUServerVolumeArgs'],
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 firewallrule_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 labels: Optional[pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic: Optional[pulumi.Input['VCPUServerNicArgs']] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a VCPUServer resource.
        :param pulumi.Input[int] cores: [integer] Number of server CPU cores.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[int] ram: [integer] The amount of memory for the server in MB.
        :param pulumi.Input['VCPUServerVolumeArgs'] volume: See the Volume section.
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. E.g: `AUTO`, `ZONE_1`, `ZONE_2`. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] firewallrule_ids: The associated firewall rules.
        :param pulumi.Input[str] hostname: (Computed)[string] The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] The password for the image.
        :param pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]] labels: A label can be seen as an object with only two required fields: `key` and `value`, both of the `string` type. Please check the example presented above to see how a `label` can be used in the plan. A server can have multiple labels.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input['VCPUServerNicArgs'] nic: See the Nic section.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
               
               > **⚠ WARNING**
               >
               > ssh_keys field is immutable.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_keys: [list] Immutable List of absolute or relative paths to files containing public SSH key that will be injected into IonosCloud provided Linux images. Also accepts ssh keys directly. Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation. Does not support `~` expansion to homedir in the given path.
        :param pulumi.Input[str] vm_state: Sets the power state of the vcpu server. Possible values: `RUNNING` or `SHUTOFF`.
        """
        pulumi.set(__self__, "cores", cores)
        pulumi.set(__self__, "datacenter_id", datacenter_id)
        pulumi.set(__self__, "ram", ram)
        pulumi.set(__self__, "volume", volume)
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if boot_cdrom is not None:
            warnings.warn("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""", DeprecationWarning)
            pulumi.log.warn("""boot_cdrom is deprecated: Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
        if boot_cdrom is not None:
            pulumi.set(__self__, "boot_cdrom", boot_cdrom)
        if boot_image is not None:
            pulumi.set(__self__, "boot_image", boot_image)
        if firewallrule_ids is not None:
            pulumi.set(__self__, "firewallrule_ids", firewallrule_ids)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if image_name is not None:
            pulumi.set(__self__, "image_name", image_name)
        if image_password is not None:
            pulumi.set(__self__, "image_password", image_password)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nic is not None:
            pulumi.set(__self__, "nic", nic)
        if security_groups_ids is not None:
            pulumi.set(__self__, "security_groups_ids", security_groups_ids)
        if ssh_keys is not None:
            pulumi.set(__self__, "ssh_keys", ssh_keys)
        if vm_state is not None:
            pulumi.set(__self__, "vm_state", vm_state)

    @property
    @pulumi.getter
    def cores(self) -> pulumi.Input[int]:
        """
        [integer] Number of server CPU cores.
        """
        return pulumi.get(self, "cores")

    @cores.setter
    def cores(self, value: pulumi.Input[int]):
        pulumi.set(self, "cores", value)

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> pulumi.Input[str]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @datacenter_id.setter
    def datacenter_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "datacenter_id", value)

    @property
    @pulumi.getter
    def ram(self) -> pulumi.Input[int]:
        """
        [integer] The amount of memory for the server in MB.
        """
        return pulumi.get(self, "ram")

    @ram.setter
    def ram(self, value: pulumi.Input[int]):
        pulumi.set(self, "ram", value)

    @property
    @pulumi.getter
    def volume(self) -> pulumi.Input['VCPUServerVolumeArgs']:
        """
        See the Volume section.
        """
        return pulumi.get(self, "volume")

    @volume.setter
    def volume(self, value: pulumi.Input['VCPUServerVolumeArgs']):
        pulumi.set(self, "volume", value)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The availability zone in which the server should exist. E.g: `AUTO`, `ZONE_1`, `ZONE_2`. This property is immutable.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter(name="bootCdrom")
    @_utilities.deprecated("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
    def boot_cdrom(self) -> Optional[pulumi.Input[str]]:
        """
        ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        """
        return pulumi.get(self, "boot_cdrom")

    @boot_cdrom.setter
    def boot_cdrom(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_cdrom", value)

    @property
    @pulumi.getter(name="bootImage")
    def boot_image(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        """
        return pulumi.get(self, "boot_image")

    @boot_image.setter
    def boot_image(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_image", value)

    @property
    @pulumi.getter(name="firewallruleIds")
    def firewallrule_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The associated firewall rules.
        """
        return pulumi.get(self, "firewallrule_ids")

    @firewallrule_ids.setter
    def firewallrule_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "firewallrule_ids", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[string] The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        """
        return pulumi.get(self, "image_name")

    @image_name.setter
    def image_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_name", value)

    @property
    @pulumi.getter(name="imagePassword")
    def image_password(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The password for the image.
        """
        return pulumi.get(self, "image_password")

    @image_password.setter
    def image_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_password", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]]]:
        """
        A label can be seen as an object with only two required fields: `key` and `value`, both of the `string` type. Please check the example presented above to see how a `label` can be used in the plan. A server can have multiple labels.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name of the server.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def nic(self) -> Optional[pulumi.Input['VCPUServerNicArgs']]:
        """
        See the Nic section.
        """
        return pulumi.get(self, "nic")

    @nic.setter
    def nic(self, value: Optional[pulumi.Input['VCPUServerNicArgs']]):
        pulumi.set(self, "nic", value)

    @property
    @pulumi.getter(name="securityGroupsIds")
    def security_groups_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of Security Group IDs for the resource.

        > **⚠ WARNING**
        >
        > ssh_keys field is immutable.
        """
        return pulumi.get(self, "security_groups_ids")

    @security_groups_ids.setter
    def security_groups_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups_ids", value)

    @property
    @pulumi.getter(name="sshKeys")
    def ssh_keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        [list] Immutable List of absolute or relative paths to files containing public SSH key that will be injected into IonosCloud provided Linux images. Also accepts ssh keys directly. Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation. Does not support `~` expansion to homedir in the given path.
        """
        return pulumi.get(self, "ssh_keys")

    @ssh_keys.setter
    def ssh_keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ssh_keys", value)

    @property
    @pulumi.getter(name="vmState")
    def vm_state(self) -> Optional[pulumi.Input[str]]:
        """
        Sets the power state of the vcpu server. Possible values: `RUNNING` or `SHUTOFF`.
        """
        return pulumi.get(self, "vm_state")

    @vm_state.setter
    def vm_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_state", value)


@pulumi.input_type
class _VCPUServerState:
    def __init__(__self__, *,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 boot_volume: Optional[pulumi.Input[str]] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 cpu_family: Optional[pulumi.Input[str]] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 firewallrule_id: Optional[pulumi.Input[str]] = None,
                 firewallrule_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 inline_volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 labels: Optional[pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic: Optional[pulumi.Input['VCPUServerNicArgs']] = None,
                 primary_ip: Optional[pulumi.Input[str]] = None,
                 primary_nic: Optional[pulumi.Input[str]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None,
                 volume: Optional[pulumi.Input['VCPUServerVolumeArgs']] = None):
        """
        Input properties used for looking up and filtering VCPUServer resources.
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. E.g: `AUTO`, `ZONE_1`, `ZONE_2`. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[str] boot_volume: The associated boot volume.
        :param pulumi.Input[int] cores: [integer] Number of server CPU cores.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[str] firewallrule_id: The associated firewall rule.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] firewallrule_ids: The associated firewall rules.
        :param pulumi.Input[str] hostname: (Computed)[string] The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] The password for the image.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] inline_volume_ids: A list with the IDs for the volumes that are defined inside the server resource.
        :param pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]] labels: A label can be seen as an object with only two required fields: `key` and `value`, both of the `string` type. Please check the example presented above to see how a `label` can be used in the plan. A server can have multiple labels.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input['VCPUServerNicArgs'] nic: See the Nic section.
        :param pulumi.Input[str] primary_ip: The associated IP address.
        :param pulumi.Input[str] primary_nic: The associated NIC.
        :param pulumi.Input[int] ram: [integer] The amount of memory for the server in MB.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
               
               > **⚠ WARNING**
               >
               > ssh_keys field is immutable.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_keys: [list] Immutable List of absolute or relative paths to files containing public SSH key that will be injected into IonosCloud provided Linux images. Also accepts ssh keys directly. Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation. Does not support `~` expansion to homedir in the given path.
        :param pulumi.Input[str] vm_state: Sets the power state of the vcpu server. Possible values: `RUNNING` or `SHUTOFF`.
        :param pulumi.Input['VCPUServerVolumeArgs'] volume: See the Volume section.
        """
        if availability_zone is not None:
            pulumi.set(__self__, "availability_zone", availability_zone)
        if boot_cdrom is not None:
            warnings.warn("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""", DeprecationWarning)
            pulumi.log.warn("""boot_cdrom is deprecated: Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
        if boot_cdrom is not None:
            pulumi.set(__self__, "boot_cdrom", boot_cdrom)
        if boot_image is not None:
            pulumi.set(__self__, "boot_image", boot_image)
        if boot_volume is not None:
            pulumi.set(__self__, "boot_volume", boot_volume)
        if cores is not None:
            pulumi.set(__self__, "cores", cores)
        if cpu_family is not None:
            pulumi.set(__self__, "cpu_family", cpu_family)
        if datacenter_id is not None:
            pulumi.set(__self__, "datacenter_id", datacenter_id)
        if firewallrule_id is not None:
            pulumi.set(__self__, "firewallrule_id", firewallrule_id)
        if firewallrule_ids is not None:
            pulumi.set(__self__, "firewallrule_ids", firewallrule_ids)
        if hostname is not None:
            pulumi.set(__self__, "hostname", hostname)
        if image_name is not None:
            pulumi.set(__self__, "image_name", image_name)
        if image_password is not None:
            pulumi.set(__self__, "image_password", image_password)
        if inline_volume_ids is not None:
            pulumi.set(__self__, "inline_volume_ids", inline_volume_ids)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nic is not None:
            pulumi.set(__self__, "nic", nic)
        if primary_ip is not None:
            pulumi.set(__self__, "primary_ip", primary_ip)
        if primary_nic is not None:
            pulumi.set(__self__, "primary_nic", primary_nic)
        if ram is not None:
            pulumi.set(__self__, "ram", ram)
        if security_groups_ids is not None:
            pulumi.set(__self__, "security_groups_ids", security_groups_ids)
        if ssh_keys is not None:
            pulumi.set(__self__, "ssh_keys", ssh_keys)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if vm_state is not None:
            pulumi.set(__self__, "vm_state", vm_state)
        if volume is not None:
            pulumi.set(__self__, "volume", volume)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The availability zone in which the server should exist. E.g: `AUTO`, `ZONE_1`, `ZONE_2`. This property is immutable.
        """
        return pulumi.get(self, "availability_zone")

    @availability_zone.setter
    def availability_zone(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "availability_zone", value)

    @property
    @pulumi.getter(name="bootCdrom")
    @_utilities.deprecated("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
    def boot_cdrom(self) -> Optional[pulumi.Input[str]]:
        """
        ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        """
        return pulumi.get(self, "boot_cdrom")

    @boot_cdrom.setter
    def boot_cdrom(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_cdrom", value)

    @property
    @pulumi.getter(name="bootImage")
    def boot_image(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        """
        return pulumi.get(self, "boot_image")

    @boot_image.setter
    def boot_image(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_image", value)

    @property
    @pulumi.getter(name="bootVolume")
    def boot_volume(self) -> Optional[pulumi.Input[str]]:
        """
        The associated boot volume.
        """
        return pulumi.get(self, "boot_volume")

    @boot_volume.setter
    def boot_volume(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "boot_volume", value)

    @property
    @pulumi.getter
    def cores(self) -> Optional[pulumi.Input[int]]:
        """
        [integer] Number of server CPU cores.
        """
        return pulumi.get(self, "cores")

    @cores.setter
    def cores(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cores", value)

    @property
    @pulumi.getter(name="cpuFamily")
    def cpu_family(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "cpu_family")

    @cpu_family.setter
    def cpu_family(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cpu_family", value)

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @datacenter_id.setter
    def datacenter_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "datacenter_id", value)

    @property
    @pulumi.getter(name="firewallruleId")
    def firewallrule_id(self) -> Optional[pulumi.Input[str]]:
        """
        The associated firewall rule.
        """
        return pulumi.get(self, "firewallrule_id")

    @firewallrule_id.setter
    def firewallrule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "firewallrule_id", value)

    @property
    @pulumi.getter(name="firewallruleIds")
    def firewallrule_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The associated firewall rules.
        """
        return pulumi.get(self, "firewallrule_ids")

    @firewallrule_ids.setter
    def firewallrule_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "firewallrule_ids", value)

    @property
    @pulumi.getter
    def hostname(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[string] The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        """
        return pulumi.get(self, "hostname")

    @hostname.setter
    def hostname(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "hostname", value)

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        """
        return pulumi.get(self, "image_name")

    @image_name.setter
    def image_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_name", value)

    @property
    @pulumi.getter(name="imagePassword")
    def image_password(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The password for the image.
        """
        return pulumi.get(self, "image_password")

    @image_password.setter
    def image_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "image_password", value)

    @property
    @pulumi.getter(name="inlineVolumeIds")
    def inline_volume_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list with the IDs for the volumes that are defined inside the server resource.
        """
        return pulumi.get(self, "inline_volume_ids")

    @inline_volume_ids.setter
    def inline_volume_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "inline_volume_ids", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]]]:
        """
        A label can be seen as an object with only two required fields: `key` and `value`, both of the `string` type. Please check the example presented above to see how a `label` can be used in the plan. A server can have multiple labels.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['VCPUServerLabelArgs']]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name of the server.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def nic(self) -> Optional[pulumi.Input['VCPUServerNicArgs']]:
        """
        See the Nic section.
        """
        return pulumi.get(self, "nic")

    @nic.setter
    def nic(self, value: Optional[pulumi.Input['VCPUServerNicArgs']]):
        pulumi.set(self, "nic", value)

    @property
    @pulumi.getter(name="primaryIp")
    def primary_ip(self) -> Optional[pulumi.Input[str]]:
        """
        The associated IP address.
        """
        return pulumi.get(self, "primary_ip")

    @primary_ip.setter
    def primary_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_ip", value)

    @property
    @pulumi.getter(name="primaryNic")
    def primary_nic(self) -> Optional[pulumi.Input[str]]:
        """
        The associated NIC.
        """
        return pulumi.get(self, "primary_nic")

    @primary_nic.setter
    def primary_nic(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "primary_nic", value)

    @property
    @pulumi.getter
    def ram(self) -> Optional[pulumi.Input[int]]:
        """
        [integer] The amount of memory for the server in MB.
        """
        return pulumi.get(self, "ram")

    @ram.setter
    def ram(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ram", value)

    @property
    @pulumi.getter(name="securityGroupsIds")
    def security_groups_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of Security Group IDs for the resource.

        > **⚠ WARNING**
        >
        > ssh_keys field is immutable.
        """
        return pulumi.get(self, "security_groups_ids")

    @security_groups_ids.setter
    def security_groups_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_groups_ids", value)

    @property
    @pulumi.getter(name="sshKeys")
    def ssh_keys(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        [list] Immutable List of absolute or relative paths to files containing public SSH key that will be injected into IonosCloud provided Linux images. Also accepts ssh keys directly. Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation. Does not support `~` expansion to homedir in the given path.
        """
        return pulumi.get(self, "ssh_keys")

    @ssh_keys.setter
    def ssh_keys(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "ssh_keys", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="vmState")
    def vm_state(self) -> Optional[pulumi.Input[str]]:
        """
        Sets the power state of the vcpu server. Possible values: `RUNNING` or `SHUTOFF`.
        """
        return pulumi.get(self, "vm_state")

    @vm_state.setter
    def vm_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vm_state", value)

    @property
    @pulumi.getter
    def volume(self) -> Optional[pulumi.Input['VCPUServerVolumeArgs']]:
        """
        See the Volume section.
        """
        return pulumi.get(self, "volume")

    @volume.setter
    def volume(self, value: Optional[pulumi.Input['VCPUServerVolumeArgs']]):
        pulumi.set(self, "volume", value)


class VCPUServer(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 firewallrule_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 labels: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VCPUServerLabelArgs', 'VCPUServerLabelArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic: Optional[pulumi.Input[Union['VCPUServerNicArgs', 'VCPUServerNicArgsDict']]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None,
                 volume: Optional[pulumi.Input[Union['VCPUServerVolumeArgs', 'VCPUServerVolumeArgsDict']]] = None,
                 __props__=None):
        """
        Manages a **VCPU Server** on IonosCloud.

        ## Example Usage

        ### VCPU Server

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.get_image(type="HDD",
            image_alias="ubuntu:latest",
            location="us/las")
        example_datacenter = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="de/txl",
            description="Datacenter Description",
            sec_auth_protection=False)
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example_datacenter.id,
            public=True,
            name="Lan Example")
        example_ip_block = ionoscloud.compute.IPBlock("example",
            location=example_datacenter.location,
            size=4,
            name="IP Block Example")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_vcpu_server = ionoscloud.compute.VCPUServer("example",
            name="VCPU Server Example",
            datacenter_id=example_datacenter.id,
            cores=1,
            ram=1024,
            availability_zone="ZONE_1",
            image_name=example.id,
            image_password=server_image_password["result"],
            volume={
                "name": "system",
                "size": 5,
                "disk_type": "SSD Standard",
                "user_data": "foo",
                "bus": "VIRTIO",
                "availability_zone": "ZONE_1",
            },
            nic={
                "lan": example_lan.id,
                "name": "system",
                "dhcp": True,
                "firewall_active": True,
                "firewall_type": "BIDIRECTIONAL",
                "ips": [
                    example_ip_block.ips[0],
                    example_ip_block.ips[1],
                ],
                "firewalls": [{
                    "protocol": "TCP",
                    "name": "SSH",
                    "port_range_start": 22,
                    "port_range_end": 22,
                    "source_mac": "00:0a:95:9d:68:17",
                    "source_ip": example_ip_block.ips[2],
                    "target_ip": example_ip_block.ips[3],
                    "type": "EGRESS",
                }],
            },
            labels=[
                {
                    "key": "labelkey1",
                    "value": "labelvalue1",
                },
                {
                    "key": "labelkey2",
                    "value": "labelvalue2",
                },
            ])
        ```

        ## Notes

        Please note that for any secondary volume, you need to set the **licence_type** property to **UNKNOWN**

        ⚠️ **Note:** Important for deleting an `firewall` rule from within a list of inline resources defined on the same nic. There is one limitation to removing one firewall rule
        from the middle of the list of `firewall` rules. The existing rules will be modified and the last one will be deleted.

        ## Import

        Resource VCPU Server can be imported using the `resource id` and the `datacenter id`, for example, passing only resource id and datacenter id means that the first nic found linked to the server will be attached to it.

        ```sh
        $ pulumi import ionoscloud:compute/vCPUServer:VCPUServer myserver datacenter uuid/server uuid
        ```

        Optionally, you can pass `primary_nic` and `firewallrule_id` so pulumi will know to import also the first nic and firewall rule (if it exists on the server):

        ```sh
        $ pulumi import ionoscloud:compute/vCPUServer:VCPUServer myserver datacenter uuid/server uuid/primary nic id/firewall rule id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. E.g: `AUTO`, `ZONE_1`, `ZONE_2`. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[int] cores: [integer] Number of server CPU cores.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] firewallrule_ids: The associated firewall rules.
        :param pulumi.Input[str] hostname: (Computed)[string] The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] The password for the image.
        :param pulumi.Input[Sequence[pulumi.Input[Union['VCPUServerLabelArgs', 'VCPUServerLabelArgsDict']]]] labels: A label can be seen as an object with only two required fields: `key` and `value`, both of the `string` type. Please check the example presented above to see how a `label` can be used in the plan. A server can have multiple labels.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input[Union['VCPUServerNicArgs', 'VCPUServerNicArgsDict']] nic: See the Nic section.
        :param pulumi.Input[int] ram: [integer] The amount of memory for the server in MB.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
               
               > **⚠ WARNING**
               >
               > ssh_keys field is immutable.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_keys: [list] Immutable List of absolute or relative paths to files containing public SSH key that will be injected into IonosCloud provided Linux images. Also accepts ssh keys directly. Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation. Does not support `~` expansion to homedir in the given path.
        :param pulumi.Input[str] vm_state: Sets the power state of the vcpu server. Possible values: `RUNNING` or `SHUTOFF`.
        :param pulumi.Input[Union['VCPUServerVolumeArgs', 'VCPUServerVolumeArgsDict']] volume: See the Volume section.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VCPUServerArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a **VCPU Server** on IonosCloud.

        ## Example Usage

        ### VCPU Server

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.get_image(type="HDD",
            image_alias="ubuntu:latest",
            location="us/las")
        example_datacenter = ionoscloud.compute.Datacenter("example",
            name="Datacenter Example",
            location="de/txl",
            description="Datacenter Description",
            sec_auth_protection=False)
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example_datacenter.id,
            public=True,
            name="Lan Example")
        example_ip_block = ionoscloud.compute.IPBlock("example",
            location=example_datacenter.location,
            size=4,
            name="IP Block Example")
        server_image_password = random.index.Password("server_image_password",
            length=16,
            special=False)
        example_vcpu_server = ionoscloud.compute.VCPUServer("example",
            name="VCPU Server Example",
            datacenter_id=example_datacenter.id,
            cores=1,
            ram=1024,
            availability_zone="ZONE_1",
            image_name=example.id,
            image_password=server_image_password["result"],
            volume={
                "name": "system",
                "size": 5,
                "disk_type": "SSD Standard",
                "user_data": "foo",
                "bus": "VIRTIO",
                "availability_zone": "ZONE_1",
            },
            nic={
                "lan": example_lan.id,
                "name": "system",
                "dhcp": True,
                "firewall_active": True,
                "firewall_type": "BIDIRECTIONAL",
                "ips": [
                    example_ip_block.ips[0],
                    example_ip_block.ips[1],
                ],
                "firewalls": [{
                    "protocol": "TCP",
                    "name": "SSH",
                    "port_range_start": 22,
                    "port_range_end": 22,
                    "source_mac": "00:0a:95:9d:68:17",
                    "source_ip": example_ip_block.ips[2],
                    "target_ip": example_ip_block.ips[3],
                    "type": "EGRESS",
                }],
            },
            labels=[
                {
                    "key": "labelkey1",
                    "value": "labelvalue1",
                },
                {
                    "key": "labelkey2",
                    "value": "labelvalue2",
                },
            ])
        ```

        ## Notes

        Please note that for any secondary volume, you need to set the **licence_type** property to **UNKNOWN**

        ⚠️ **Note:** Important for deleting an `firewall` rule from within a list of inline resources defined on the same nic. There is one limitation to removing one firewall rule
        from the middle of the list of `firewall` rules. The existing rules will be modified and the last one will be deleted.

        ## Import

        Resource VCPU Server can be imported using the `resource id` and the `datacenter id`, for example, passing only resource id and datacenter id means that the first nic found linked to the server will be attached to it.

        ```sh
        $ pulumi import ionoscloud:compute/vCPUServer:VCPUServer myserver datacenter uuid/server uuid
        ```

        Optionally, you can pass `primary_nic` and `firewallrule_id` so pulumi will know to import also the first nic and firewall rule (if it exists on the server):

        ```sh
        $ pulumi import ionoscloud:compute/vCPUServer:VCPUServer myserver datacenter uuid/server uuid/primary nic id/firewall rule id
        ```

        :param str resource_name: The name of the resource.
        :param VCPUServerArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VCPUServerArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 availability_zone: Optional[pulumi.Input[str]] = None,
                 boot_cdrom: Optional[pulumi.Input[str]] = None,
                 boot_image: Optional[pulumi.Input[str]] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 datacenter_id: Optional[pulumi.Input[str]] = None,
                 firewallrule_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostname: Optional[pulumi.Input[str]] = None,
                 image_name: Optional[pulumi.Input[str]] = None,
                 image_password: Optional[pulumi.Input[str]] = None,
                 labels: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VCPUServerLabelArgs', 'VCPUServerLabelArgsDict']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nic: Optional[pulumi.Input[Union['VCPUServerNicArgs', 'VCPUServerNicArgsDict']]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 vm_state: Optional[pulumi.Input[str]] = None,
                 volume: Optional[pulumi.Input[Union['VCPUServerVolumeArgs', 'VCPUServerVolumeArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VCPUServerArgs.__new__(VCPUServerArgs)

            __props__.__dict__["availability_zone"] = availability_zone
            __props__.__dict__["boot_cdrom"] = boot_cdrom
            __props__.__dict__["boot_image"] = boot_image
            if cores is None and not opts.urn:
                raise TypeError("Missing required property 'cores'")
            __props__.__dict__["cores"] = cores
            if datacenter_id is None and not opts.urn:
                raise TypeError("Missing required property 'datacenter_id'")
            __props__.__dict__["datacenter_id"] = datacenter_id
            __props__.__dict__["firewallrule_ids"] = firewallrule_ids
            __props__.__dict__["hostname"] = hostname
            __props__.__dict__["image_name"] = image_name
            __props__.__dict__["image_password"] = None if image_password is None else pulumi.Output.secret(image_password)
            __props__.__dict__["labels"] = labels
            __props__.__dict__["name"] = name
            __props__.__dict__["nic"] = nic
            if ram is None and not opts.urn:
                raise TypeError("Missing required property 'ram'")
            __props__.__dict__["ram"] = ram
            __props__.__dict__["security_groups_ids"] = security_groups_ids
            __props__.__dict__["ssh_keys"] = ssh_keys
            __props__.__dict__["vm_state"] = vm_state
            if volume is None and not opts.urn:
                raise TypeError("Missing required property 'volume'")
            __props__.__dict__["volume"] = volume
            __props__.__dict__["boot_volume"] = None
            __props__.__dict__["cpu_family"] = None
            __props__.__dict__["firewallrule_id"] = None
            __props__.__dict__["inline_volume_ids"] = None
            __props__.__dict__["primary_ip"] = None
            __props__.__dict__["primary_nic"] = None
            __props__.__dict__["type"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["imagePassword"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(VCPUServer, __self__).__init__(
            'ionoscloud:compute/vCPUServer:VCPUServer',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            availability_zone: Optional[pulumi.Input[str]] = None,
            boot_cdrom: Optional[pulumi.Input[str]] = None,
            boot_image: Optional[pulumi.Input[str]] = None,
            boot_volume: Optional[pulumi.Input[str]] = None,
            cores: Optional[pulumi.Input[int]] = None,
            cpu_family: Optional[pulumi.Input[str]] = None,
            datacenter_id: Optional[pulumi.Input[str]] = None,
            firewallrule_id: Optional[pulumi.Input[str]] = None,
            firewallrule_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            hostname: Optional[pulumi.Input[str]] = None,
            image_name: Optional[pulumi.Input[str]] = None,
            image_password: Optional[pulumi.Input[str]] = None,
            inline_volume_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            labels: Optional[pulumi.Input[Sequence[pulumi.Input[Union['VCPUServerLabelArgs', 'VCPUServerLabelArgsDict']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            nic: Optional[pulumi.Input[Union['VCPUServerNicArgs', 'VCPUServerNicArgsDict']]] = None,
            primary_ip: Optional[pulumi.Input[str]] = None,
            primary_nic: Optional[pulumi.Input[str]] = None,
            ram: Optional[pulumi.Input[int]] = None,
            security_groups_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            ssh_keys: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[str]] = None,
            vm_state: Optional[pulumi.Input[str]] = None,
            volume: Optional[pulumi.Input[Union['VCPUServerVolumeArgs', 'VCPUServerVolumeArgsDict']]] = None) -> 'VCPUServer':
        """
        Get an existing VCPUServer resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] availability_zone: [string] The availability zone in which the server should exist. E.g: `AUTO`, `ZONE_1`, `ZONE_2`. This property is immutable.
        :param pulumi.Input[str] boot_cdrom: ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        :param pulumi.Input[str] boot_image: [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        :param pulumi.Input[str] boot_volume: The associated boot volume.
        :param pulumi.Input[int] cores: [integer] Number of server CPU cores.
        :param pulumi.Input[str] datacenter_id: [string] The ID of a Virtual Data Center.
        :param pulumi.Input[str] firewallrule_id: The associated firewall rule.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] firewallrule_ids: The associated firewall rules.
        :param pulumi.Input[str] hostname: (Computed)[string] The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        :param pulumi.Input[str] image_name: [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        :param pulumi.Input[str] image_password: [string] The password for the image.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] inline_volume_ids: A list with the IDs for the volumes that are defined inside the server resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['VCPUServerLabelArgs', 'VCPUServerLabelArgsDict']]]] labels: A label can be seen as an object with only two required fields: `key` and `value`, both of the `string` type. Please check the example presented above to see how a `label` can be used in the plan. A server can have multiple labels.
        :param pulumi.Input[str] name: [string] The name of the server.
        :param pulumi.Input[Union['VCPUServerNicArgs', 'VCPUServerNicArgsDict']] nic: See the Nic section.
        :param pulumi.Input[str] primary_ip: The associated IP address.
        :param pulumi.Input[str] primary_nic: The associated NIC.
        :param pulumi.Input[int] ram: [integer] The amount of memory for the server in MB.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_groups_ids: The list of Security Group IDs for the resource.
               
               > **⚠ WARNING**
               >
               > ssh_keys field is immutable.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] ssh_keys: [list] Immutable List of absolute or relative paths to files containing public SSH key that will be injected into IonosCloud provided Linux images. Also accepts ssh keys directly. Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation. Does not support `~` expansion to homedir in the given path.
        :param pulumi.Input[str] vm_state: Sets the power state of the vcpu server. Possible values: `RUNNING` or `SHUTOFF`.
        :param pulumi.Input[Union['VCPUServerVolumeArgs', 'VCPUServerVolumeArgsDict']] volume: See the Volume section.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VCPUServerState.__new__(_VCPUServerState)

        __props__.__dict__["availability_zone"] = availability_zone
        __props__.__dict__["boot_cdrom"] = boot_cdrom
        __props__.__dict__["boot_image"] = boot_image
        __props__.__dict__["boot_volume"] = boot_volume
        __props__.__dict__["cores"] = cores
        __props__.__dict__["cpu_family"] = cpu_family
        __props__.__dict__["datacenter_id"] = datacenter_id
        __props__.__dict__["firewallrule_id"] = firewallrule_id
        __props__.__dict__["firewallrule_ids"] = firewallrule_ids
        __props__.__dict__["hostname"] = hostname
        __props__.__dict__["image_name"] = image_name
        __props__.__dict__["image_password"] = image_password
        __props__.__dict__["inline_volume_ids"] = inline_volume_ids
        __props__.__dict__["labels"] = labels
        __props__.__dict__["name"] = name
        __props__.__dict__["nic"] = nic
        __props__.__dict__["primary_ip"] = primary_ip
        __props__.__dict__["primary_nic"] = primary_nic
        __props__.__dict__["ram"] = ram
        __props__.__dict__["security_groups_ids"] = security_groups_ids
        __props__.__dict__["ssh_keys"] = ssh_keys
        __props__.__dict__["type"] = type
        __props__.__dict__["vm_state"] = vm_state
        __props__.__dict__["volume"] = volume
        return VCPUServer(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="availabilityZone")
    def availability_zone(self) -> pulumi.Output[str]:
        """
        [string] The availability zone in which the server should exist. E.g: `AUTO`, `ZONE_1`, `ZONE_2`. This property is immutable.
        """
        return pulumi.get(self, "availability_zone")

    @property
    @pulumi.getter(name="bootCdrom")
    @_utilities.deprecated("""Please use the 'ionoscloud_server_boot_device_selection' resource for managing the boot device of the server.""")
    def boot_cdrom(self) -> pulumi.Output[str]:
        """
        ***DEPRECATED*** Please refer to compute.BootDeviceSelection (Optional)[string] The associated boot drive, if any. Must be the UUID of a bootable CDROM image that can be retrieved using the compute_get_image data source.
        """
        return pulumi.get(self, "boot_cdrom")

    @property
    @pulumi.getter(name="bootImage")
    def boot_image(self) -> pulumi.Output[str]:
        """
        [string] The image or snapshot UUID / name. May also be an image alias. It is required if `licence_type` is not provided.
        """
        return pulumi.get(self, "boot_image")

    @property
    @pulumi.getter(name="bootVolume")
    def boot_volume(self) -> pulumi.Output[str]:
        """
        The associated boot volume.
        """
        return pulumi.get(self, "boot_volume")

    @property
    @pulumi.getter
    def cores(self) -> pulumi.Output[int]:
        """
        [integer] Number of server CPU cores.
        """
        return pulumi.get(self, "cores")

    @property
    @pulumi.getter(name="cpuFamily")
    def cpu_family(self) -> pulumi.Output[str]:
        return pulumi.get(self, "cpu_family")

    @property
    @pulumi.getter(name="datacenterId")
    def datacenter_id(self) -> pulumi.Output[str]:
        """
        [string] The ID of a Virtual Data Center.
        """
        return pulumi.get(self, "datacenter_id")

    @property
    @pulumi.getter(name="firewallruleId")
    def firewallrule_id(self) -> pulumi.Output[str]:
        """
        The associated firewall rule.
        """
        return pulumi.get(self, "firewallrule_id")

    @property
    @pulumi.getter(name="firewallruleIds")
    def firewallrule_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        The associated firewall rules.
        """
        return pulumi.get(self, "firewallrule_ids")

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Output[str]:
        """
        (Computed)[string] The hostname of the resource. Allowed characters are a-z, 0-9 and - (minus). Hostname should not start with minus and should not be longer than 63 characters. If no value provided explicitly, it will be populated with the name of the server
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="imageName")
    def image_name(self) -> pulumi.Output[str]:
        """
        [string] The name, ID or alias of the image. May also be a snapshot ID. It is required if `licence_type` is not provided. Attribute is immutable.
        """
        return pulumi.get(self, "image_name")

    @property
    @pulumi.getter(name="imagePassword")
    def image_password(self) -> pulumi.Output[str]:
        """
        [string] The password for the image.
        """
        return pulumi.get(self, "image_password")

    @property
    @pulumi.getter(name="inlineVolumeIds")
    def inline_volume_ids(self) -> pulumi.Output[Sequence[str]]:
        """
        A list with the IDs for the volumes that are defined inside the server resource.
        """
        return pulumi.get(self, "inline_volume_ids")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Optional[Sequence['outputs.VCPUServerLabel']]]:
        """
        A label can be seen as an object with only two required fields: `key` and `value`, both of the `string` type. Please check the example presented above to see how a `label` can be used in the plan. A server can have multiple labels.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        [string] The name of the server.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def nic(self) -> pulumi.Output[Optional['outputs.VCPUServerNic']]:
        """
        See the Nic section.
        """
        return pulumi.get(self, "nic")

    @property
    @pulumi.getter(name="primaryIp")
    def primary_ip(self) -> pulumi.Output[str]:
        """
        The associated IP address.
        """
        return pulumi.get(self, "primary_ip")

    @property
    @pulumi.getter(name="primaryNic")
    def primary_nic(self) -> pulumi.Output[str]:
        """
        The associated NIC.
        """
        return pulumi.get(self, "primary_nic")

    @property
    @pulumi.getter
    def ram(self) -> pulumi.Output[int]:
        """
        [integer] The amount of memory for the server in MB.
        """
        return pulumi.get(self, "ram")

    @property
    @pulumi.getter(name="securityGroupsIds")
    def security_groups_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The list of Security Group IDs for the resource.

        > **⚠ WARNING**
        >
        > ssh_keys field is immutable.
        """
        return pulumi.get(self, "security_groups_ids")

    @property
    @pulumi.getter(name="sshKeys")
    def ssh_keys(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        [list] Immutable List of absolute or relative paths to files containing public SSH key that will be injected into IonosCloud provided Linux images. Also accepts ssh keys directly. Public SSH keys are set on the image as authorized keys for appropriate SSH login to the instance using the corresponding private key. This field may only be set in creation requests. When reading, it always returns null. SSH keys are only supported if a public Linux image is used for the volume creation. Does not support `~` expansion to homedir in the given path.
        """
        return pulumi.get(self, "ssh_keys")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="vmState")
    def vm_state(self) -> pulumi.Output[str]:
        """
        Sets the power state of the vcpu server. Possible values: `RUNNING` or `SHUTOFF`.
        """
        return pulumi.get(self, "vm_state")

    @property
    @pulumi.getter
    def volume(self) -> pulumi.Output['outputs.VCPUServerVolume']:
        """
        See the Volume section.
        """
        return pulumi.get(self, "volume")

