# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetRegistryLocationsResult',
    'AwaitableGetRegistryLocationsResult',
    'get_registry_locations',
    'get_registry_locations_output',
]

@pulumi.output_type
class GetRegistryLocationsResult:
    """
    A collection of values returned by getRegistryLocations.
    """
    def __init__(__self__, id=None, locations=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if locations and not isinstance(locations, list):
            raise TypeError("Expected argument 'locations' to be a list")
        pulumi.set(__self__, "locations", locations)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def locations(self) -> Sequence[str]:
        """
        list of container registry locations
        """
        return pulumi.get(self, "locations")


class AwaitableGetRegistryLocationsResult(GetRegistryLocationsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRegistryLocationsResult(
            id=self.id,
            locations=self.locations)


def get_registry_locations(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRegistryLocationsResult:
    """
    The **Container Registry Locations data source** can be used to get a list of Container Registry Locations

    ## Example Usage

    ```python
    import pulumi
    import pulumi_ionoscloud as ionoscloud

    example = ionoscloud.creg.get_registry_locations()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('ionoscloud:creg/getRegistryLocations:getRegistryLocations', __args__, opts=opts, typ=GetRegistryLocationsResult).value

    return AwaitableGetRegistryLocationsResult(
        id=pulumi.get(__ret__, 'id'),
        locations=pulumi.get(__ret__, 'locations'))
def get_registry_locations_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRegistryLocationsResult]:
    """
    The **Container Registry Locations data source** can be used to get a list of Container Registry Locations

    ## Example Usage

    ```python
    import pulumi
    import pulumi_ionoscloud as ionoscloud

    example = ionoscloud.creg.get_registry_locations()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('ionoscloud:creg/getRegistryLocations:getRegistryLocations', __args__, opts=opts, typ=GetRegistryLocationsResult)
    return __ret__.apply(lambda __response__: GetRegistryLocationsResult(
        id=pulumi.get(__response__, 'id'),
        locations=pulumi.get(__response__, 'locations')))
