# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['MariaDBClusterArgs', 'MariaDBCluster']

@pulumi.input_type
class MariaDBClusterArgs:
    def __init__(__self__, *,
                 connections: pulumi.Input['MariaDBClusterConnectionsArgs'],
                 cores: pulumi.Input[int],
                 credentials: pulumi.Input['MariaDBClusterCredentialsArgs'],
                 display_name: pulumi.Input[str],
                 instances: pulumi.Input[int],
                 mariadb_version: pulumi.Input[str],
                 ram: pulumi.Input[int],
                 storage_size: pulumi.Input[int],
                 location: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input['MariaDBClusterMaintenanceWindowArgs']] = None):
        """
        The set of arguments for constructing a MariaDBCluster resource.
        :param pulumi.Input['MariaDBClusterConnectionsArgs'] connections: The network connection for your cluster. Only one connection is allowed.
        :param pulumi.Input[int] cores: [int] The number of CPU cores per instance.
        :param pulumi.Input['MariaDBClusterCredentialsArgs'] credentials: Credentials for the database user to be created.
        :param pulumi.Input[str] display_name: [string] The friendly name of your cluster.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one primary and n-1 secondary).
        :param pulumi.Input[str] mariadb_version: [string] The MariaDB version of your cluster. Cannot be downgraded.
        :param pulumi.Input[int] ram: [int] The amount of memory per instance in gigabytes (GB).
        :param pulumi.Input[int] storage_size: [int] The amount of storage per instance in gigabytes (GB).
        :param pulumi.Input[str] location: [string] The location in which the cluster will be created. Different service endpoints are used based on location, possible options are: "de/fra", "de/txl", "es/vit", "fr/par", "gb/lhr", "us/ewr", "us/las", "us/mci". If not set, the endpoint will be the one corresponding to "de/txl".
        :param pulumi.Input['MariaDBClusterMaintenanceWindowArgs'] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur
        """
        pulumi.set(__self__, "connections", connections)
        pulumi.set(__self__, "cores", cores)
        pulumi.set(__self__, "credentials", credentials)
        pulumi.set(__self__, "display_name", display_name)
        pulumi.set(__self__, "instances", instances)
        pulumi.set(__self__, "mariadb_version", mariadb_version)
        pulumi.set(__self__, "ram", ram)
        pulumi.set(__self__, "storage_size", storage_size)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if maintenance_window is not None:
            pulumi.set(__self__, "maintenance_window", maintenance_window)

    @property
    @pulumi.getter
    def connections(self) -> pulumi.Input['MariaDBClusterConnectionsArgs']:
        """
        The network connection for your cluster. Only one connection is allowed.
        """
        return pulumi.get(self, "connections")

    @connections.setter
    def connections(self, value: pulumi.Input['MariaDBClusterConnectionsArgs']):
        pulumi.set(self, "connections", value)

    @property
    @pulumi.getter
    def cores(self) -> pulumi.Input[int]:
        """
        [int] The number of CPU cores per instance.
        """
        return pulumi.get(self, "cores")

    @cores.setter
    def cores(self, value: pulumi.Input[int]):
        pulumi.set(self, "cores", value)

    @property
    @pulumi.getter
    def credentials(self) -> pulumi.Input['MariaDBClusterCredentialsArgs']:
        """
        Credentials for the database user to be created.
        """
        return pulumi.get(self, "credentials")

    @credentials.setter
    def credentials(self, value: pulumi.Input['MariaDBClusterCredentialsArgs']):
        pulumi.set(self, "credentials", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Input[str]:
        """
        [string] The friendly name of your cluster.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter
    def instances(self) -> pulumi.Input[int]:
        """
        [int] The total number of instances in the cluster (one primary and n-1 secondary).
        """
        return pulumi.get(self, "instances")

    @instances.setter
    def instances(self, value: pulumi.Input[int]):
        pulumi.set(self, "instances", value)

    @property
    @pulumi.getter(name="mariadbVersion")
    def mariadb_version(self) -> pulumi.Input[str]:
        """
        [string] The MariaDB version of your cluster. Cannot be downgraded.
        """
        return pulumi.get(self, "mariadb_version")

    @mariadb_version.setter
    def mariadb_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "mariadb_version", value)

    @property
    @pulumi.getter
    def ram(self) -> pulumi.Input[int]:
        """
        [int] The amount of memory per instance in gigabytes (GB).
        """
        return pulumi.get(self, "ram")

    @ram.setter
    def ram(self, value: pulumi.Input[int]):
        pulumi.set(self, "ram", value)

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> pulumi.Input[int]:
        """
        [int] The amount of storage per instance in gigabytes (GB).
        """
        return pulumi.get(self, "storage_size")

    @storage_size.setter
    def storage_size(self, value: pulumi.Input[int]):
        pulumi.set(self, "storage_size", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The location in which the cluster will be created. Different service endpoints are used based on location, possible options are: "de/fra", "de/txl", "es/vit", "fr/par", "gb/lhr", "us/ewr", "us/las", "us/mci". If not set, the endpoint will be the one corresponding to "de/txl".
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> Optional[pulumi.Input['MariaDBClusterMaintenanceWindowArgs']]:
        """
        (Computed) A weekly 4 hour-long window, during which maintenance might occur
        """
        return pulumi.get(self, "maintenance_window")

    @maintenance_window.setter
    def maintenance_window(self, value: Optional[pulumi.Input['MariaDBClusterMaintenanceWindowArgs']]):
        pulumi.set(self, "maintenance_window", value)


@pulumi.input_type
class _MariaDBClusterState:
    def __init__(__self__, *,
                 connections: Optional[pulumi.Input['MariaDBClusterConnectionsArgs']] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 credentials: Optional[pulumi.Input['MariaDBClusterCredentialsArgs']] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 dns_name: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[int]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input['MariaDBClusterMaintenanceWindowArgs']] = None,
                 mariadb_version: Optional[pulumi.Input[str]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 storage_size: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering MariaDBCluster resources.
        :param pulumi.Input['MariaDBClusterConnectionsArgs'] connections: The network connection for your cluster. Only one connection is allowed.
        :param pulumi.Input[int] cores: [int] The number of CPU cores per instance.
        :param pulumi.Input['MariaDBClusterCredentialsArgs'] credentials: Credentials for the database user to be created.
        :param pulumi.Input[str] display_name: [string] The friendly name of your cluster.
        :param pulumi.Input[str] dns_name: [string] The DNS name pointing to your cluster.
               
               > **⚠ WARNING:** `IONOS_API_URL_MARIADB` can be used to set a custom API URL for the MariaDB Cluster. `location` field needs to be empty, otherwise it will override the custom API URL. Setting `endpoint` or `IONOS_API_URL` does not have any effect.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one primary and n-1 secondary).
        :param pulumi.Input[str] location: [string] The location in which the cluster will be created. Different service endpoints are used based on location, possible options are: "de/fra", "de/txl", "es/vit", "fr/par", "gb/lhr", "us/ewr", "us/las", "us/mci". If not set, the endpoint will be the one corresponding to "de/txl".
        :param pulumi.Input['MariaDBClusterMaintenanceWindowArgs'] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur
        :param pulumi.Input[str] mariadb_version: [string] The MariaDB version of your cluster. Cannot be downgraded.
        :param pulumi.Input[int] ram: [int] The amount of memory per instance in gigabytes (GB).
        :param pulumi.Input[int] storage_size: [int] The amount of storage per instance in gigabytes (GB).
        """
        if connections is not None:
            pulumi.set(__self__, "connections", connections)
        if cores is not None:
            pulumi.set(__self__, "cores", cores)
        if credentials is not None:
            pulumi.set(__self__, "credentials", credentials)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if dns_name is not None:
            pulumi.set(__self__, "dns_name", dns_name)
        if instances is not None:
            pulumi.set(__self__, "instances", instances)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if maintenance_window is not None:
            pulumi.set(__self__, "maintenance_window", maintenance_window)
        if mariadb_version is not None:
            pulumi.set(__self__, "mariadb_version", mariadb_version)
        if ram is not None:
            pulumi.set(__self__, "ram", ram)
        if storage_size is not None:
            pulumi.set(__self__, "storage_size", storage_size)

    @property
    @pulumi.getter
    def connections(self) -> Optional[pulumi.Input['MariaDBClusterConnectionsArgs']]:
        """
        The network connection for your cluster. Only one connection is allowed.
        """
        return pulumi.get(self, "connections")

    @connections.setter
    def connections(self, value: Optional[pulumi.Input['MariaDBClusterConnectionsArgs']]):
        pulumi.set(self, "connections", value)

    @property
    @pulumi.getter
    def cores(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The number of CPU cores per instance.
        """
        return pulumi.get(self, "cores")

    @cores.setter
    def cores(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cores", value)

    @property
    @pulumi.getter
    def credentials(self) -> Optional[pulumi.Input['MariaDBClusterCredentialsArgs']]:
        """
        Credentials for the database user to be created.
        """
        return pulumi.get(self, "credentials")

    @credentials.setter
    def credentials(self, value: Optional[pulumi.Input['MariaDBClusterCredentialsArgs']]):
        pulumi.set(self, "credentials", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The friendly name of your cluster.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="dnsName")
    def dns_name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The DNS name pointing to your cluster.

        > **⚠ WARNING:** `IONOS_API_URL_MARIADB` can be used to set a custom API URL for the MariaDB Cluster. `location` field needs to be empty, otherwise it will override the custom API URL. Setting `endpoint` or `IONOS_API_URL` does not have any effect.
        """
        return pulumi.get(self, "dns_name")

    @dns_name.setter
    def dns_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dns_name", value)

    @property
    @pulumi.getter
    def instances(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The total number of instances in the cluster (one primary and n-1 secondary).
        """
        return pulumi.get(self, "instances")

    @instances.setter
    def instances(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "instances", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The location in which the cluster will be created. Different service endpoints are used based on location, possible options are: "de/fra", "de/txl", "es/vit", "fr/par", "gb/lhr", "us/ewr", "us/las", "us/mci". If not set, the endpoint will be the one corresponding to "de/txl".
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> Optional[pulumi.Input['MariaDBClusterMaintenanceWindowArgs']]:
        """
        (Computed) A weekly 4 hour-long window, during which maintenance might occur
        """
        return pulumi.get(self, "maintenance_window")

    @maintenance_window.setter
    def maintenance_window(self, value: Optional[pulumi.Input['MariaDBClusterMaintenanceWindowArgs']]):
        pulumi.set(self, "maintenance_window", value)

    @property
    @pulumi.getter(name="mariadbVersion")
    def mariadb_version(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The MariaDB version of your cluster. Cannot be downgraded.
        """
        return pulumi.get(self, "mariadb_version")

    @mariadb_version.setter
    def mariadb_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mariadb_version", value)

    @property
    @pulumi.getter
    def ram(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The amount of memory per instance in gigabytes (GB).
        """
        return pulumi.get(self, "ram")

    @ram.setter
    def ram(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ram", value)

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The amount of storage per instance in gigabytes (GB).
        """
        return pulumi.get(self, "storage_size")

    @storage_size.setter
    def storage_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "storage_size", value)


class MariaDBCluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connections: Optional[pulumi.Input[Union['MariaDBClusterConnectionsArgs', 'MariaDBClusterConnectionsArgsDict']]] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 credentials: Optional[pulumi.Input[Union['MariaDBClusterCredentialsArgs', 'MariaDBClusterCredentialsArgsDict']]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[int]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input[Union['MariaDBClusterMaintenanceWindowArgs', 'MariaDBClusterMaintenanceWindowArgsDict']]] = None,
                 mariadb_version: Optional[pulumi.Input[str]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 storage_size: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Manages a **DBaaS MariaDB Cluster**.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.Datacenter("example",
            name="example",
            location="de/txl",
            description="Datacenter for testing DBaaS cluster")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=False,
            name="example")
        example_server = ionoscloud.compute.Server("example",
            name="example",
            datacenter_id=example.id,
            cores=2,
            ram=2048,
            availability_zone="ZONE_1",
            cpu_family="INTEL_SKYLAKE",
            image_name="rockylinux-8-GenericCloud-20230518",
            image_password="password",
            volume={
                "name": "example",
                "size": 10,
                "disk_type": "SSD Standard",
            },
            nic={
                "lan": example_lan.id,
                "name": "example",
                "dhcp": True,
            })
        cluster_password = random.index.Password("cluster_password",
            length=16,
            special=True,
            override_special=!#$%&*()-_=+[]{}<>:?)
        example_maria_db_cluster = ionoscloud.dbaas.MariaDBCluster("example",
            mariadb_version="10.6",
            location="de/txl",
            instances=1,
            cores=4,
            ram=4,
            storage_size=10,
            connections={
                "datacenter_id": example.id,
                "lan_id": example_lan.id,
                "cidr": "database_ip_cidr_from_nic",
            },
            display_name="MariaDB_cluster",
            maintenance_window={
                "day_of_the_week": "Sunday",
                "time": "09:00:00",
            },
            credentials={
                "username": "username",
                "password": cluster_password["result"],
            })
        ```

        ## Import

        Resource DBaaS MariaDB Cluster can be imported using the `cluster_id` and the `location`, separated by `:`, e.g.

        ```sh
        $ pulumi import ionoscloud:dbaas/mariaDBCluster:MariaDBCluster mycluster location:cluster uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['MariaDBClusterConnectionsArgs', 'MariaDBClusterConnectionsArgsDict']] connections: The network connection for your cluster. Only one connection is allowed.
        :param pulumi.Input[int] cores: [int] The number of CPU cores per instance.
        :param pulumi.Input[Union['MariaDBClusterCredentialsArgs', 'MariaDBClusterCredentialsArgsDict']] credentials: Credentials for the database user to be created.
        :param pulumi.Input[str] display_name: [string] The friendly name of your cluster.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one primary and n-1 secondary).
        :param pulumi.Input[str] location: [string] The location in which the cluster will be created. Different service endpoints are used based on location, possible options are: "de/fra", "de/txl", "es/vit", "fr/par", "gb/lhr", "us/ewr", "us/las", "us/mci". If not set, the endpoint will be the one corresponding to "de/txl".
        :param pulumi.Input[Union['MariaDBClusterMaintenanceWindowArgs', 'MariaDBClusterMaintenanceWindowArgsDict']] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur
        :param pulumi.Input[str] mariadb_version: [string] The MariaDB version of your cluster. Cannot be downgraded.
        :param pulumi.Input[int] ram: [int] The amount of memory per instance in gigabytes (GB).
        :param pulumi.Input[int] storage_size: [int] The amount of storage per instance in gigabytes (GB).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MariaDBClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a **DBaaS MariaDB Cluster**.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        example = ionoscloud.compute.Datacenter("example",
            name="example",
            location="de/txl",
            description="Datacenter for testing DBaaS cluster")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=False,
            name="example")
        example_server = ionoscloud.compute.Server("example",
            name="example",
            datacenter_id=example.id,
            cores=2,
            ram=2048,
            availability_zone="ZONE_1",
            cpu_family="INTEL_SKYLAKE",
            image_name="rockylinux-8-GenericCloud-20230518",
            image_password="password",
            volume={
                "name": "example",
                "size": 10,
                "disk_type": "SSD Standard",
            },
            nic={
                "lan": example_lan.id,
                "name": "example",
                "dhcp": True,
            })
        cluster_password = random.index.Password("cluster_password",
            length=16,
            special=True,
            override_special=!#$%&*()-_=+[]{}<>:?)
        example_maria_db_cluster = ionoscloud.dbaas.MariaDBCluster("example",
            mariadb_version="10.6",
            location="de/txl",
            instances=1,
            cores=4,
            ram=4,
            storage_size=10,
            connections={
                "datacenter_id": example.id,
                "lan_id": example_lan.id,
                "cidr": "database_ip_cidr_from_nic",
            },
            display_name="MariaDB_cluster",
            maintenance_window={
                "day_of_the_week": "Sunday",
                "time": "09:00:00",
            },
            credentials={
                "username": "username",
                "password": cluster_password["result"],
            })
        ```

        ## Import

        Resource DBaaS MariaDB Cluster can be imported using the `cluster_id` and the `location`, separated by `:`, e.g.

        ```sh
        $ pulumi import ionoscloud:dbaas/mariaDBCluster:MariaDBCluster mycluster location:cluster uuid
        ```

        :param str resource_name: The name of the resource.
        :param MariaDBClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MariaDBClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 connections: Optional[pulumi.Input[Union['MariaDBClusterConnectionsArgs', 'MariaDBClusterConnectionsArgsDict']]] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 credentials: Optional[pulumi.Input[Union['MariaDBClusterCredentialsArgs', 'MariaDBClusterCredentialsArgsDict']]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[int]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input[Union['MariaDBClusterMaintenanceWindowArgs', 'MariaDBClusterMaintenanceWindowArgsDict']]] = None,
                 mariadb_version: Optional[pulumi.Input[str]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 storage_size: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MariaDBClusterArgs.__new__(MariaDBClusterArgs)

            if connections is None and not opts.urn:
                raise TypeError("Missing required property 'connections'")
            __props__.__dict__["connections"] = connections
            if cores is None and not opts.urn:
                raise TypeError("Missing required property 'cores'")
            __props__.__dict__["cores"] = cores
            if credentials is None and not opts.urn:
                raise TypeError("Missing required property 'credentials'")
            __props__.__dict__["credentials"] = credentials
            if display_name is None and not opts.urn:
                raise TypeError("Missing required property 'display_name'")
            __props__.__dict__["display_name"] = display_name
            if instances is None and not opts.urn:
                raise TypeError("Missing required property 'instances'")
            __props__.__dict__["instances"] = instances
            __props__.__dict__["location"] = location
            __props__.__dict__["maintenance_window"] = maintenance_window
            if mariadb_version is None and not opts.urn:
                raise TypeError("Missing required property 'mariadb_version'")
            __props__.__dict__["mariadb_version"] = mariadb_version
            if ram is None and not opts.urn:
                raise TypeError("Missing required property 'ram'")
            __props__.__dict__["ram"] = ram
            if storage_size is None and not opts.urn:
                raise TypeError("Missing required property 'storage_size'")
            __props__.__dict__["storage_size"] = storage_size
            __props__.__dict__["dns_name"] = None
        super(MariaDBCluster, __self__).__init__(
            'ionoscloud:dbaas/mariaDBCluster:MariaDBCluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            connections: Optional[pulumi.Input[Union['MariaDBClusterConnectionsArgs', 'MariaDBClusterConnectionsArgsDict']]] = None,
            cores: Optional[pulumi.Input[int]] = None,
            credentials: Optional[pulumi.Input[Union['MariaDBClusterCredentialsArgs', 'MariaDBClusterCredentialsArgsDict']]] = None,
            display_name: Optional[pulumi.Input[str]] = None,
            dns_name: Optional[pulumi.Input[str]] = None,
            instances: Optional[pulumi.Input[int]] = None,
            location: Optional[pulumi.Input[str]] = None,
            maintenance_window: Optional[pulumi.Input[Union['MariaDBClusterMaintenanceWindowArgs', 'MariaDBClusterMaintenanceWindowArgsDict']]] = None,
            mariadb_version: Optional[pulumi.Input[str]] = None,
            ram: Optional[pulumi.Input[int]] = None,
            storage_size: Optional[pulumi.Input[int]] = None) -> 'MariaDBCluster':
        """
        Get an existing MariaDBCluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['MariaDBClusterConnectionsArgs', 'MariaDBClusterConnectionsArgsDict']] connections: The network connection for your cluster. Only one connection is allowed.
        :param pulumi.Input[int] cores: [int] The number of CPU cores per instance.
        :param pulumi.Input[Union['MariaDBClusterCredentialsArgs', 'MariaDBClusterCredentialsArgsDict']] credentials: Credentials for the database user to be created.
        :param pulumi.Input[str] display_name: [string] The friendly name of your cluster.
        :param pulumi.Input[str] dns_name: [string] The DNS name pointing to your cluster.
               
               > **⚠ WARNING:** `IONOS_API_URL_MARIADB` can be used to set a custom API URL for the MariaDB Cluster. `location` field needs to be empty, otherwise it will override the custom API URL. Setting `endpoint` or `IONOS_API_URL` does not have any effect.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one primary and n-1 secondary).
        :param pulumi.Input[str] location: [string] The location in which the cluster will be created. Different service endpoints are used based on location, possible options are: "de/fra", "de/txl", "es/vit", "fr/par", "gb/lhr", "us/ewr", "us/las", "us/mci". If not set, the endpoint will be the one corresponding to "de/txl".
        :param pulumi.Input[Union['MariaDBClusterMaintenanceWindowArgs', 'MariaDBClusterMaintenanceWindowArgsDict']] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur
        :param pulumi.Input[str] mariadb_version: [string] The MariaDB version of your cluster. Cannot be downgraded.
        :param pulumi.Input[int] ram: [int] The amount of memory per instance in gigabytes (GB).
        :param pulumi.Input[int] storage_size: [int] The amount of storage per instance in gigabytes (GB).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MariaDBClusterState.__new__(_MariaDBClusterState)

        __props__.__dict__["connections"] = connections
        __props__.__dict__["cores"] = cores
        __props__.__dict__["credentials"] = credentials
        __props__.__dict__["display_name"] = display_name
        __props__.__dict__["dns_name"] = dns_name
        __props__.__dict__["instances"] = instances
        __props__.__dict__["location"] = location
        __props__.__dict__["maintenance_window"] = maintenance_window
        __props__.__dict__["mariadb_version"] = mariadb_version
        __props__.__dict__["ram"] = ram
        __props__.__dict__["storage_size"] = storage_size
        return MariaDBCluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def connections(self) -> pulumi.Output['outputs.MariaDBClusterConnections']:
        """
        The network connection for your cluster. Only one connection is allowed.
        """
        return pulumi.get(self, "connections")

    @property
    @pulumi.getter
    def cores(self) -> pulumi.Output[int]:
        """
        [int] The number of CPU cores per instance.
        """
        return pulumi.get(self, "cores")

    @property
    @pulumi.getter
    def credentials(self) -> pulumi.Output['outputs.MariaDBClusterCredentials']:
        """
        Credentials for the database user to be created.
        """
        return pulumi.get(self, "credentials")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[str]:
        """
        [string] The friendly name of your cluster.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter(name="dnsName")
    def dns_name(self) -> pulumi.Output[str]:
        """
        [string] The DNS name pointing to your cluster.

        > **⚠ WARNING:** `IONOS_API_URL_MARIADB` can be used to set a custom API URL for the MariaDB Cluster. `location` field needs to be empty, otherwise it will override the custom API URL. Setting `endpoint` or `IONOS_API_URL` does not have any effect.
        """
        return pulumi.get(self, "dns_name")

    @property
    @pulumi.getter
    def instances(self) -> pulumi.Output[int]:
        """
        [int] The total number of instances in the cluster (one primary and n-1 secondary).
        """
        return pulumi.get(self, "instances")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[str]]:
        """
        [string] The location in which the cluster will be created. Different service endpoints are used based on location, possible options are: "de/fra", "de/txl", "es/vit", "fr/par", "gb/lhr", "us/ewr", "us/las", "us/mci". If not set, the endpoint will be the one corresponding to "de/txl".
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> pulumi.Output['outputs.MariaDBClusterMaintenanceWindow']:
        """
        (Computed) A weekly 4 hour-long window, during which maintenance might occur
        """
        return pulumi.get(self, "maintenance_window")

    @property
    @pulumi.getter(name="mariadbVersion")
    def mariadb_version(self) -> pulumi.Output[str]:
        """
        [string] The MariaDB version of your cluster. Cannot be downgraded.
        """
        return pulumi.get(self, "mariadb_version")

    @property
    @pulumi.getter
    def ram(self) -> pulumi.Output[int]:
        """
        [int] The amount of memory per instance in gigabytes (GB).
        """
        return pulumi.get(self, "ram")

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> pulumi.Output[int]:
        """
        [int] The amount of storage per instance in gigabytes (GB).
        """
        return pulumi.get(self, "storage_size")

