# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['MongoClusterArgs', 'MongoCluster']

@pulumi.input_type
class MongoClusterArgs:
    def __init__(__self__, *,
                 connections: pulumi.Input['MongoClusterConnectionsArgs'],
                 display_name: pulumi.Input[str],
                 instances: pulumi.Input[int],
                 location: pulumi.Input[str],
                 mongodb_version: pulumi.Input[str],
                 backup: Optional[pulumi.Input['MongoClusterBackupArgs']] = None,
                 bi_connector: Optional[pulumi.Input['MongoClusterBiConnectorArgs']] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 edition: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input['MongoClusterMaintenanceWindowArgs']] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 shards: Optional[pulumi.Input[int]] = None,
                 storage_size: Optional[pulumi.Input[int]] = None,
                 storage_type: Optional[pulumi.Input[str]] = None,
                 template_id: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a MongoCluster resource.
        :param pulumi.Input['MongoClusterConnectionsArgs'] connections: [List] Details about the network connection for your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] display_name: [string] The name of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one master and n-1 standbys). Example: 1, 3, 5, 7. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] location: [string] The physical location where the cluster will be created. Property cannot be modified after datacenter creation (disallowed in update requests). Available locations: de/txl, gb/lhr, es/vit. Update forces cluster re-creation.
        :param pulumi.Input[str] mongodb_version: [string] The MongoDB version of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input['MongoClusterBackupArgs'] backup: [list]
        :param pulumi.Input['MongoClusterBiConnectorArgs'] bi_connector: (Computed)The MongoDB Connector for Business Intelligence allows you to query a MongoDB database using SQL commands to aid in data analysis.
        :param pulumi.Input[int] cores: (Computed)[int] The number of CPU cores per replica. Required for enterprise edition.
        :param pulumi.Input[str] edition: (Computed)[string] Cluster edition. Playground, business or enterprise.
        :param pulumi.Input['MongoClusterMaintenanceWindowArgs'] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur.  Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] ram: (Computed)[int]The amount of memory per instance in megabytes. Required for enterprise edition.
        :param pulumi.Input[int] shards: [int]The total number of shards in the cluster.
        :param pulumi.Input[int] storage_size: (Computed)[int] The amount of storage per instance in MB. Required for enterprise edition.
        :param pulumi.Input[str] storage_type: (Computed)[String] The storage type used in your cluster. Required for enterprise edition.
        :param pulumi.Input[str] template_id: [string] The unique ID of the template, which specifies the number of cores, storage size, and memory. Updates to the value of the field force the cluster to be re-created. Required for playground and business editions. Must not be provided for enterprise edition.
        :param pulumi.Input[str] type: (Computed)[string]The cluster type, either `replicaset` or `sharded-cluster`.
        """
        pulumi.set(__self__, "connections", connections)
        pulumi.set(__self__, "display_name", display_name)
        pulumi.set(__self__, "instances", instances)
        pulumi.set(__self__, "location", location)
        pulumi.set(__self__, "mongodb_version", mongodb_version)
        if backup is not None:
            pulumi.set(__self__, "backup", backup)
        if bi_connector is not None:
            pulumi.set(__self__, "bi_connector", bi_connector)
        if cores is not None:
            pulumi.set(__self__, "cores", cores)
        if edition is not None:
            pulumi.set(__self__, "edition", edition)
        if maintenance_window is not None:
            pulumi.set(__self__, "maintenance_window", maintenance_window)
        if ram is not None:
            pulumi.set(__self__, "ram", ram)
        if shards is not None:
            pulumi.set(__self__, "shards", shards)
        if storage_size is not None:
            pulumi.set(__self__, "storage_size", storage_size)
        if storage_type is not None:
            pulumi.set(__self__, "storage_type", storage_type)
        if template_id is not None:
            pulumi.set(__self__, "template_id", template_id)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def connections(self) -> pulumi.Input['MongoClusterConnectionsArgs']:
        """
        [List] Details about the network connection for your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "connections")

    @connections.setter
    def connections(self, value: pulumi.Input['MongoClusterConnectionsArgs']):
        pulumi.set(self, "connections", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Input[str]:
        """
        [string] The name of your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter
    def instances(self) -> pulumi.Input[int]:
        """
        [int] The total number of instances in the cluster (one master and n-1 standbys). Example: 1, 3, 5, 7. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "instances")

    @instances.setter
    def instances(self, value: pulumi.Input[int]):
        pulumi.set(self, "instances", value)

    @property
    @pulumi.getter
    def location(self) -> pulumi.Input[str]:
        """
        [string] The physical location where the cluster will be created. Property cannot be modified after datacenter creation (disallowed in update requests). Available locations: de/txl, gb/lhr, es/vit. Update forces cluster re-creation.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: pulumi.Input[str]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="mongodbVersion")
    def mongodb_version(self) -> pulumi.Input[str]:
        """
        [string] The MongoDB version of your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "mongodb_version")

    @mongodb_version.setter
    def mongodb_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "mongodb_version", value)

    @property
    @pulumi.getter
    def backup(self) -> Optional[pulumi.Input['MongoClusterBackupArgs']]:
        """
        [list]
        """
        return pulumi.get(self, "backup")

    @backup.setter
    def backup(self, value: Optional[pulumi.Input['MongoClusterBackupArgs']]):
        pulumi.set(self, "backup", value)

    @property
    @pulumi.getter(name="biConnector")
    def bi_connector(self) -> Optional[pulumi.Input['MongoClusterBiConnectorArgs']]:
        """
        (Computed)The MongoDB Connector for Business Intelligence allows you to query a MongoDB database using SQL commands to aid in data analysis.
        """
        return pulumi.get(self, "bi_connector")

    @bi_connector.setter
    def bi_connector(self, value: Optional[pulumi.Input['MongoClusterBiConnectorArgs']]):
        pulumi.set(self, "bi_connector", value)

    @property
    @pulumi.getter
    def cores(self) -> Optional[pulumi.Input[int]]:
        """
        (Computed)[int] The number of CPU cores per replica. Required for enterprise edition.
        """
        return pulumi.get(self, "cores")

    @cores.setter
    def cores(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cores", value)

    @property
    @pulumi.getter
    def edition(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[string] Cluster edition. Playground, business or enterprise.
        """
        return pulumi.get(self, "edition")

    @edition.setter
    def edition(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "edition", value)

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> Optional[pulumi.Input['MongoClusterMaintenanceWindowArgs']]:
        """
        (Computed) A weekly 4 hour-long window, during which maintenance might occur.  Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "maintenance_window")

    @maintenance_window.setter
    def maintenance_window(self, value: Optional[pulumi.Input['MongoClusterMaintenanceWindowArgs']]):
        pulumi.set(self, "maintenance_window", value)

    @property
    @pulumi.getter
    def ram(self) -> Optional[pulumi.Input[int]]:
        """
        (Computed)[int]The amount of memory per instance in megabytes. Required for enterprise edition.
        """
        return pulumi.get(self, "ram")

    @ram.setter
    def ram(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ram", value)

    @property
    @pulumi.getter
    def shards(self) -> Optional[pulumi.Input[int]]:
        """
        [int]The total number of shards in the cluster.
        """
        return pulumi.get(self, "shards")

    @shards.setter
    def shards(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "shards", value)

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> Optional[pulumi.Input[int]]:
        """
        (Computed)[int] The amount of storage per instance in MB. Required for enterprise edition.
        """
        return pulumi.get(self, "storage_size")

    @storage_size.setter
    def storage_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "storage_size", value)

    @property
    @pulumi.getter(name="storageType")
    def storage_type(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[String] The storage type used in your cluster. Required for enterprise edition.
        """
        return pulumi.get(self, "storage_type")

    @storage_type.setter
    def storage_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "storage_type", value)

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The unique ID of the template, which specifies the number of cores, storage size, and memory. Updates to the value of the field force the cluster to be re-created. Required for playground and business editions. Must not be provided for enterprise edition.
        """
        return pulumi.get(self, "template_id")

    @template_id.setter
    def template_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "template_id", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[string]The cluster type, either `replicaset` or `sharded-cluster`.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class _MongoClusterState:
    def __init__(__self__, *,
                 backup: Optional[pulumi.Input['MongoClusterBackupArgs']] = None,
                 bi_connector: Optional[pulumi.Input['MongoClusterBiConnectorArgs']] = None,
                 connection_string: Optional[pulumi.Input[str]] = None,
                 connections: Optional[pulumi.Input['MongoClusterConnectionsArgs']] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 edition: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[int]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input['MongoClusterMaintenanceWindowArgs']] = None,
                 mongodb_version: Optional[pulumi.Input[str]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 shards: Optional[pulumi.Input[int]] = None,
                 storage_size: Optional[pulumi.Input[int]] = None,
                 storage_type: Optional[pulumi.Input[str]] = None,
                 template_id: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering MongoCluster resources.
        :param pulumi.Input['MongoClusterBackupArgs'] backup: [list]
        :param pulumi.Input['MongoClusterBiConnectorArgs'] bi_connector: (Computed)The MongoDB Connector for Business Intelligence allows you to query a MongoDB database using SQL commands to aid in data analysis.
        :param pulumi.Input[str] connection_string: [string] The physical location where the cluster will be created. This will be where all of your instances live. Updates to the value of the field force the cluster to be re-created. Available locations: de/txl, gb/lhr, es/vit
        :param pulumi.Input['MongoClusterConnectionsArgs'] connections: [List] Details about the network connection for your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] cores: (Computed)[int] The number of CPU cores per replica. Required for enterprise edition.
        :param pulumi.Input[str] display_name: [string] The name of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] edition: (Computed)[string] Cluster edition. Playground, business or enterprise.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one master and n-1 standbys). Example: 1, 3, 5, 7. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] location: [string] The physical location where the cluster will be created. Property cannot be modified after datacenter creation (disallowed in update requests). Available locations: de/txl, gb/lhr, es/vit. Update forces cluster re-creation.
        :param pulumi.Input['MongoClusterMaintenanceWindowArgs'] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur.  Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] mongodb_version: [string] The MongoDB version of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] ram: (Computed)[int]The amount of memory per instance in megabytes. Required for enterprise edition.
        :param pulumi.Input[int] shards: [int]The total number of shards in the cluster.
        :param pulumi.Input[int] storage_size: (Computed)[int] The amount of storage per instance in MB. Required for enterprise edition.
        :param pulumi.Input[str] storage_type: (Computed)[String] The storage type used in your cluster. Required for enterprise edition.
        :param pulumi.Input[str] template_id: [string] The unique ID of the template, which specifies the number of cores, storage size, and memory. Updates to the value of the field force the cluster to be re-created. Required for playground and business editions. Must not be provided for enterprise edition.
        :param pulumi.Input[str] type: (Computed)[string]The cluster type, either `replicaset` or `sharded-cluster`.
        """
        if backup is not None:
            pulumi.set(__self__, "backup", backup)
        if bi_connector is not None:
            pulumi.set(__self__, "bi_connector", bi_connector)
        if connection_string is not None:
            pulumi.set(__self__, "connection_string", connection_string)
        if connections is not None:
            pulumi.set(__self__, "connections", connections)
        if cores is not None:
            pulumi.set(__self__, "cores", cores)
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if edition is not None:
            pulumi.set(__self__, "edition", edition)
        if instances is not None:
            pulumi.set(__self__, "instances", instances)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if maintenance_window is not None:
            pulumi.set(__self__, "maintenance_window", maintenance_window)
        if mongodb_version is not None:
            pulumi.set(__self__, "mongodb_version", mongodb_version)
        if ram is not None:
            pulumi.set(__self__, "ram", ram)
        if shards is not None:
            pulumi.set(__self__, "shards", shards)
        if storage_size is not None:
            pulumi.set(__self__, "storage_size", storage_size)
        if storage_type is not None:
            pulumi.set(__self__, "storage_type", storage_type)
        if template_id is not None:
            pulumi.set(__self__, "template_id", template_id)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def backup(self) -> Optional[pulumi.Input['MongoClusterBackupArgs']]:
        """
        [list]
        """
        return pulumi.get(self, "backup")

    @backup.setter
    def backup(self, value: Optional[pulumi.Input['MongoClusterBackupArgs']]):
        pulumi.set(self, "backup", value)

    @property
    @pulumi.getter(name="biConnector")
    def bi_connector(self) -> Optional[pulumi.Input['MongoClusterBiConnectorArgs']]:
        """
        (Computed)The MongoDB Connector for Business Intelligence allows you to query a MongoDB database using SQL commands to aid in data analysis.
        """
        return pulumi.get(self, "bi_connector")

    @bi_connector.setter
    def bi_connector(self, value: Optional[pulumi.Input['MongoClusterBiConnectorArgs']]):
        pulumi.set(self, "bi_connector", value)

    @property
    @pulumi.getter(name="connectionString")
    def connection_string(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The physical location where the cluster will be created. This will be where all of your instances live. Updates to the value of the field force the cluster to be re-created. Available locations: de/txl, gb/lhr, es/vit
        """
        return pulumi.get(self, "connection_string")

    @connection_string.setter
    def connection_string(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "connection_string", value)

    @property
    @pulumi.getter
    def connections(self) -> Optional[pulumi.Input['MongoClusterConnectionsArgs']]:
        """
        [List] Details about the network connection for your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "connections")

    @connections.setter
    def connections(self, value: Optional[pulumi.Input['MongoClusterConnectionsArgs']]):
        pulumi.set(self, "connections", value)

    @property
    @pulumi.getter
    def cores(self) -> Optional[pulumi.Input[int]]:
        """
        (Computed)[int] The number of CPU cores per replica. Required for enterprise edition.
        """
        return pulumi.get(self, "cores")

    @cores.setter
    def cores(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "cores", value)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The name of your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter
    def edition(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[string] Cluster edition. Playground, business or enterprise.
        """
        return pulumi.get(self, "edition")

    @edition.setter
    def edition(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "edition", value)

    @property
    @pulumi.getter
    def instances(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The total number of instances in the cluster (one master and n-1 standbys). Example: 1, 3, 5, 7. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "instances")

    @instances.setter
    def instances(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "instances", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The physical location where the cluster will be created. Property cannot be modified after datacenter creation (disallowed in update requests). Available locations: de/txl, gb/lhr, es/vit. Update forces cluster re-creation.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> Optional[pulumi.Input['MongoClusterMaintenanceWindowArgs']]:
        """
        (Computed) A weekly 4 hour-long window, during which maintenance might occur.  Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "maintenance_window")

    @maintenance_window.setter
    def maintenance_window(self, value: Optional[pulumi.Input['MongoClusterMaintenanceWindowArgs']]):
        pulumi.set(self, "maintenance_window", value)

    @property
    @pulumi.getter(name="mongodbVersion")
    def mongodb_version(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The MongoDB version of your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "mongodb_version")

    @mongodb_version.setter
    def mongodb_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mongodb_version", value)

    @property
    @pulumi.getter
    def ram(self) -> Optional[pulumi.Input[int]]:
        """
        (Computed)[int]The amount of memory per instance in megabytes. Required for enterprise edition.
        """
        return pulumi.get(self, "ram")

    @ram.setter
    def ram(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "ram", value)

    @property
    @pulumi.getter
    def shards(self) -> Optional[pulumi.Input[int]]:
        """
        [int]The total number of shards in the cluster.
        """
        return pulumi.get(self, "shards")

    @shards.setter
    def shards(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "shards", value)

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> Optional[pulumi.Input[int]]:
        """
        (Computed)[int] The amount of storage per instance in MB. Required for enterprise edition.
        """
        return pulumi.get(self, "storage_size")

    @storage_size.setter
    def storage_size(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "storage_size", value)

    @property
    @pulumi.getter(name="storageType")
    def storage_type(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[String] The storage type used in your cluster. Required for enterprise edition.
        """
        return pulumi.get(self, "storage_type")

    @storage_type.setter
    def storage_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "storage_type", value)

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The unique ID of the template, which specifies the number of cores, storage size, and memory. Updates to the value of the field force the cluster to be re-created. Required for playground and business editions. Must not be provided for enterprise edition.
        """
        return pulumi.get(self, "template_id")

    @template_id.setter
    def template_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "template_id", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        (Computed)[string]The cluster type, either `replicaset` or `sharded-cluster`.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class MongoCluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup: Optional[pulumi.Input[Union['MongoClusterBackupArgs', 'MongoClusterBackupArgsDict']]] = None,
                 bi_connector: Optional[pulumi.Input[Union['MongoClusterBiConnectorArgs', 'MongoClusterBiConnectorArgsDict']]] = None,
                 connections: Optional[pulumi.Input[Union['MongoClusterConnectionsArgs', 'MongoClusterConnectionsArgsDict']]] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 edition: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[int]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input[Union['MongoClusterMaintenanceWindowArgs', 'MongoClusterMaintenanceWindowArgsDict']]] = None,
                 mongodb_version: Optional[pulumi.Input[str]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 shards: Optional[pulumi.Input[int]] = None,
                 storage_size: Optional[pulumi.Input[int]] = None,
                 storage_type: Optional[pulumi.Input[str]] = None,
                 template_id: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages a **DbaaS Mongo Cluster**.

        ## Example Usage

        ### Playground Or Business Editions. They Require Template_id Defined.

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        datacenter_example = ionoscloud.compute.Datacenter("datacenter_example",
            name="example",
            location="de/txl",
            description="Datacenter for testing dbaas cluster")
        lan_example = ionoscloud.compute.Lan("lan_example",
            datacenter_id=datacenter_example.id,
            public=False,
            name="example")
        example_mongo_cluster = ionoscloud.dbaas.MongoCluster("example_mongo_cluster",
            maintenance_window={
                "day_of_the_week": "Sunday",
                "time": "09:00:00",
            },
            mongodb_version="5.0",
            instances=1,
            display_name="example_mongo_cluster",
            location=datacenter_example.location,
            connections={
                "datacenter_id": datacenter_example.id,
                "lan_id": lan_example.id,
                "cidr_lists": ["192.168.1.108/24"],
            },
            template_id="6b78ea06-ee0e-4689-998c-fc9c46e781f6")
        cluster_password = random.index.Password("cluster_password",
            length=16,
            special=True,
            override_special=!#$%&*()-_=+[]{}<>:?)
        ```

        ### Enterprise Edition

        **Enterprise Support: With MongoDB Enterprise, you gain access to professional support from the MongoDB team ensuring that you receive timely assistance and expert guidance when needed. IONOS offers enterprise-grade Service Level Agreements (SLAs), guaranteeing rapid response times and 24/7 support to address any critical issues that may arise.**

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        datacenter_example = ionoscloud.compute.Datacenter("datacenter_example",
            name="example",
            location="de/txl",
            description="Datacenter for testing dbaas cluster")
        lan_example = ionoscloud.compute.Lan("lan_example",
            datacenter_id=datacenter_example.id,
            public=False,
            name="example")
        example_mongo_cluster = ionoscloud.dbaas.MongoCluster("example_mongo_cluster",
            maintenance_window={
                "day_of_the_week": "Sunday",
                "time": "09:00:00",
            },
            mongodb_version="5.0",
            instances=3,
            display_name="example_mongo_cluster",
            location=datacenter_example.location,
            connections={
                "datacenter_id": datacenter_example.id,
                "lan_id": lan_example.id,
                "cidr_lists": [
                    "192.168.1.108/24",
                    "192.168.1.109/24",
                    "192.168.1.110/24",
                ],
            },
            type="sharded-cluster",
            shards=2,
            edition="enterprise",
            ram=2048,
            cores=1,
            storage_size=5120,
            storage_type="HDD")
        cluster_password = random.index.Password("cluster_password",
            length=16,
            special=True,
            override_special=!#$%&*()-_=+[]{}<>:?)
        ```

        ## Import

        Resource DbaaS MongoDb Cluster can be imported using the `cluster_id`, e.g.

        ```sh
        $ pulumi import ionoscloud:dbaas/mongoCluster:MongoCluster mycluser cluster uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['MongoClusterBackupArgs', 'MongoClusterBackupArgsDict']] backup: [list]
        :param pulumi.Input[Union['MongoClusterBiConnectorArgs', 'MongoClusterBiConnectorArgsDict']] bi_connector: (Computed)The MongoDB Connector for Business Intelligence allows you to query a MongoDB database using SQL commands to aid in data analysis.
        :param pulumi.Input[Union['MongoClusterConnectionsArgs', 'MongoClusterConnectionsArgsDict']] connections: [List] Details about the network connection for your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] cores: (Computed)[int] The number of CPU cores per replica. Required for enterprise edition.
        :param pulumi.Input[str] display_name: [string] The name of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] edition: (Computed)[string] Cluster edition. Playground, business or enterprise.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one master and n-1 standbys). Example: 1, 3, 5, 7. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] location: [string] The physical location where the cluster will be created. Property cannot be modified after datacenter creation (disallowed in update requests). Available locations: de/txl, gb/lhr, es/vit. Update forces cluster re-creation.
        :param pulumi.Input[Union['MongoClusterMaintenanceWindowArgs', 'MongoClusterMaintenanceWindowArgsDict']] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur.  Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] mongodb_version: [string] The MongoDB version of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] ram: (Computed)[int]The amount of memory per instance in megabytes. Required for enterprise edition.
        :param pulumi.Input[int] shards: [int]The total number of shards in the cluster.
        :param pulumi.Input[int] storage_size: (Computed)[int] The amount of storage per instance in MB. Required for enterprise edition.
        :param pulumi.Input[str] storage_type: (Computed)[String] The storage type used in your cluster. Required for enterprise edition.
        :param pulumi.Input[str] template_id: [string] The unique ID of the template, which specifies the number of cores, storage size, and memory. Updates to the value of the field force the cluster to be re-created. Required for playground and business editions. Must not be provided for enterprise edition.
        :param pulumi.Input[str] type: (Computed)[string]The cluster type, either `replicaset` or `sharded-cluster`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MongoClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a **DbaaS Mongo Cluster**.

        ## Example Usage

        ### Playground Or Business Editions. They Require Template_id Defined.

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        datacenter_example = ionoscloud.compute.Datacenter("datacenter_example",
            name="example",
            location="de/txl",
            description="Datacenter for testing dbaas cluster")
        lan_example = ionoscloud.compute.Lan("lan_example",
            datacenter_id=datacenter_example.id,
            public=False,
            name="example")
        example_mongo_cluster = ionoscloud.dbaas.MongoCluster("example_mongo_cluster",
            maintenance_window={
                "day_of_the_week": "Sunday",
                "time": "09:00:00",
            },
            mongodb_version="5.0",
            instances=1,
            display_name="example_mongo_cluster",
            location=datacenter_example.location,
            connections={
                "datacenter_id": datacenter_example.id,
                "lan_id": lan_example.id,
                "cidr_lists": ["192.168.1.108/24"],
            },
            template_id="6b78ea06-ee0e-4689-998c-fc9c46e781f6")
        cluster_password = random.index.Password("cluster_password",
            length=16,
            special=True,
            override_special=!#$%&*()-_=+[]{}<>:?)
        ```

        ### Enterprise Edition

        **Enterprise Support: With MongoDB Enterprise, you gain access to professional support from the MongoDB team ensuring that you receive timely assistance and expert guidance when needed. IONOS offers enterprise-grade Service Level Agreements (SLAs), guaranteeing rapid response times and 24/7 support to address any critical issues that may arise.**

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        datacenter_example = ionoscloud.compute.Datacenter("datacenter_example",
            name="example",
            location="de/txl",
            description="Datacenter for testing dbaas cluster")
        lan_example = ionoscloud.compute.Lan("lan_example",
            datacenter_id=datacenter_example.id,
            public=False,
            name="example")
        example_mongo_cluster = ionoscloud.dbaas.MongoCluster("example_mongo_cluster",
            maintenance_window={
                "day_of_the_week": "Sunday",
                "time": "09:00:00",
            },
            mongodb_version="5.0",
            instances=3,
            display_name="example_mongo_cluster",
            location=datacenter_example.location,
            connections={
                "datacenter_id": datacenter_example.id,
                "lan_id": lan_example.id,
                "cidr_lists": [
                    "192.168.1.108/24",
                    "192.168.1.109/24",
                    "192.168.1.110/24",
                ],
            },
            type="sharded-cluster",
            shards=2,
            edition="enterprise",
            ram=2048,
            cores=1,
            storage_size=5120,
            storage_type="HDD")
        cluster_password = random.index.Password("cluster_password",
            length=16,
            special=True,
            override_special=!#$%&*()-_=+[]{}<>:?)
        ```

        ## Import

        Resource DbaaS MongoDb Cluster can be imported using the `cluster_id`, e.g.

        ```sh
        $ pulumi import ionoscloud:dbaas/mongoCluster:MongoCluster mycluser cluster uuid
        ```

        :param str resource_name: The name of the resource.
        :param MongoClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MongoClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup: Optional[pulumi.Input[Union['MongoClusterBackupArgs', 'MongoClusterBackupArgsDict']]] = None,
                 bi_connector: Optional[pulumi.Input[Union['MongoClusterBiConnectorArgs', 'MongoClusterBiConnectorArgsDict']]] = None,
                 connections: Optional[pulumi.Input[Union['MongoClusterConnectionsArgs', 'MongoClusterConnectionsArgsDict']]] = None,
                 cores: Optional[pulumi.Input[int]] = None,
                 display_name: Optional[pulumi.Input[str]] = None,
                 edition: Optional[pulumi.Input[str]] = None,
                 instances: Optional[pulumi.Input[int]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 maintenance_window: Optional[pulumi.Input[Union['MongoClusterMaintenanceWindowArgs', 'MongoClusterMaintenanceWindowArgsDict']]] = None,
                 mongodb_version: Optional[pulumi.Input[str]] = None,
                 ram: Optional[pulumi.Input[int]] = None,
                 shards: Optional[pulumi.Input[int]] = None,
                 storage_size: Optional[pulumi.Input[int]] = None,
                 storage_type: Optional[pulumi.Input[str]] = None,
                 template_id: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MongoClusterArgs.__new__(MongoClusterArgs)

            __props__.__dict__["backup"] = backup
            __props__.__dict__["bi_connector"] = bi_connector
            if connections is None and not opts.urn:
                raise TypeError("Missing required property 'connections'")
            __props__.__dict__["connections"] = connections
            __props__.__dict__["cores"] = cores
            if display_name is None and not opts.urn:
                raise TypeError("Missing required property 'display_name'")
            __props__.__dict__["display_name"] = display_name
            __props__.__dict__["edition"] = edition
            if instances is None and not opts.urn:
                raise TypeError("Missing required property 'instances'")
            __props__.__dict__["instances"] = instances
            if location is None and not opts.urn:
                raise TypeError("Missing required property 'location'")
            __props__.__dict__["location"] = location
            __props__.__dict__["maintenance_window"] = maintenance_window
            if mongodb_version is None and not opts.urn:
                raise TypeError("Missing required property 'mongodb_version'")
            __props__.__dict__["mongodb_version"] = mongodb_version
            __props__.__dict__["ram"] = ram
            __props__.__dict__["shards"] = shards
            __props__.__dict__["storage_size"] = storage_size
            __props__.__dict__["storage_type"] = storage_type
            __props__.__dict__["template_id"] = template_id
            __props__.__dict__["type"] = type
            __props__.__dict__["connection_string"] = None
        super(MongoCluster, __self__).__init__(
            'ionoscloud:dbaas/mongoCluster:MongoCluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            backup: Optional[pulumi.Input[Union['MongoClusterBackupArgs', 'MongoClusterBackupArgsDict']]] = None,
            bi_connector: Optional[pulumi.Input[Union['MongoClusterBiConnectorArgs', 'MongoClusterBiConnectorArgsDict']]] = None,
            connection_string: Optional[pulumi.Input[str]] = None,
            connections: Optional[pulumi.Input[Union['MongoClusterConnectionsArgs', 'MongoClusterConnectionsArgsDict']]] = None,
            cores: Optional[pulumi.Input[int]] = None,
            display_name: Optional[pulumi.Input[str]] = None,
            edition: Optional[pulumi.Input[str]] = None,
            instances: Optional[pulumi.Input[int]] = None,
            location: Optional[pulumi.Input[str]] = None,
            maintenance_window: Optional[pulumi.Input[Union['MongoClusterMaintenanceWindowArgs', 'MongoClusterMaintenanceWindowArgsDict']]] = None,
            mongodb_version: Optional[pulumi.Input[str]] = None,
            ram: Optional[pulumi.Input[int]] = None,
            shards: Optional[pulumi.Input[int]] = None,
            storage_size: Optional[pulumi.Input[int]] = None,
            storage_type: Optional[pulumi.Input[str]] = None,
            template_id: Optional[pulumi.Input[str]] = None,
            type: Optional[pulumi.Input[str]] = None) -> 'MongoCluster':
        """
        Get an existing MongoCluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['MongoClusterBackupArgs', 'MongoClusterBackupArgsDict']] backup: [list]
        :param pulumi.Input[Union['MongoClusterBiConnectorArgs', 'MongoClusterBiConnectorArgsDict']] bi_connector: (Computed)The MongoDB Connector for Business Intelligence allows you to query a MongoDB database using SQL commands to aid in data analysis.
        :param pulumi.Input[str] connection_string: [string] The physical location where the cluster will be created. This will be where all of your instances live. Updates to the value of the field force the cluster to be re-created. Available locations: de/txl, gb/lhr, es/vit
        :param pulumi.Input[Union['MongoClusterConnectionsArgs', 'MongoClusterConnectionsArgsDict']] connections: [List] Details about the network connection for your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] cores: (Computed)[int] The number of CPU cores per replica. Required for enterprise edition.
        :param pulumi.Input[str] display_name: [string] The name of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] edition: (Computed)[string] Cluster edition. Playground, business or enterprise.
        :param pulumi.Input[int] instances: [int] The total number of instances in the cluster (one master and n-1 standbys). Example: 1, 3, 5, 7. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] location: [string] The physical location where the cluster will be created. Property cannot be modified after datacenter creation (disallowed in update requests). Available locations: de/txl, gb/lhr, es/vit. Update forces cluster re-creation.
        :param pulumi.Input[Union['MongoClusterMaintenanceWindowArgs', 'MongoClusterMaintenanceWindowArgsDict']] maintenance_window: (Computed) A weekly 4 hour-long window, during which maintenance might occur.  Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[str] mongodb_version: [string] The MongoDB version of your cluster. Updates to the value of the field force the cluster to be re-created.
        :param pulumi.Input[int] ram: (Computed)[int]The amount of memory per instance in megabytes. Required for enterprise edition.
        :param pulumi.Input[int] shards: [int]The total number of shards in the cluster.
        :param pulumi.Input[int] storage_size: (Computed)[int] The amount of storage per instance in MB. Required for enterprise edition.
        :param pulumi.Input[str] storage_type: (Computed)[String] The storage type used in your cluster. Required for enterprise edition.
        :param pulumi.Input[str] template_id: [string] The unique ID of the template, which specifies the number of cores, storage size, and memory. Updates to the value of the field force the cluster to be re-created. Required for playground and business editions. Must not be provided for enterprise edition.
        :param pulumi.Input[str] type: (Computed)[string]The cluster type, either `replicaset` or `sharded-cluster`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MongoClusterState.__new__(_MongoClusterState)

        __props__.__dict__["backup"] = backup
        __props__.__dict__["bi_connector"] = bi_connector
        __props__.__dict__["connection_string"] = connection_string
        __props__.__dict__["connections"] = connections
        __props__.__dict__["cores"] = cores
        __props__.__dict__["display_name"] = display_name
        __props__.__dict__["edition"] = edition
        __props__.__dict__["instances"] = instances
        __props__.__dict__["location"] = location
        __props__.__dict__["maintenance_window"] = maintenance_window
        __props__.__dict__["mongodb_version"] = mongodb_version
        __props__.__dict__["ram"] = ram
        __props__.__dict__["shards"] = shards
        __props__.__dict__["storage_size"] = storage_size
        __props__.__dict__["storage_type"] = storage_type
        __props__.__dict__["template_id"] = template_id
        __props__.__dict__["type"] = type
        return MongoCluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def backup(self) -> pulumi.Output[Optional['outputs.MongoClusterBackup']]:
        """
        [list]
        """
        return pulumi.get(self, "backup")

    @property
    @pulumi.getter(name="biConnector")
    def bi_connector(self) -> pulumi.Output['outputs.MongoClusterBiConnector']:
        """
        (Computed)The MongoDB Connector for Business Intelligence allows you to query a MongoDB database using SQL commands to aid in data analysis.
        """
        return pulumi.get(self, "bi_connector")

    @property
    @pulumi.getter(name="connectionString")
    def connection_string(self) -> pulumi.Output[str]:
        """
        [string] The physical location where the cluster will be created. This will be where all of your instances live. Updates to the value of the field force the cluster to be re-created. Available locations: de/txl, gb/lhr, es/vit
        """
        return pulumi.get(self, "connection_string")

    @property
    @pulumi.getter
    def connections(self) -> pulumi.Output['outputs.MongoClusterConnections']:
        """
        [List] Details about the network connection for your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "connections")

    @property
    @pulumi.getter
    def cores(self) -> pulumi.Output[int]:
        """
        (Computed)[int] The number of CPU cores per replica. Required for enterprise edition.
        """
        return pulumi.get(self, "cores")

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> pulumi.Output[str]:
        """
        [string] The name of your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "display_name")

    @property
    @pulumi.getter
    def edition(self) -> pulumi.Output[str]:
        """
        (Computed)[string] Cluster edition. Playground, business or enterprise.
        """
        return pulumi.get(self, "edition")

    @property
    @pulumi.getter
    def instances(self) -> pulumi.Output[int]:
        """
        [int] The total number of instances in the cluster (one master and n-1 standbys). Example: 1, 3, 5, 7. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "instances")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        [string] The physical location where the cluster will be created. Property cannot be modified after datacenter creation (disallowed in update requests). Available locations: de/txl, gb/lhr, es/vit. Update forces cluster re-creation.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter(name="maintenanceWindow")
    def maintenance_window(self) -> pulumi.Output['outputs.MongoClusterMaintenanceWindow']:
        """
        (Computed) A weekly 4 hour-long window, during which maintenance might occur.  Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "maintenance_window")

    @property
    @pulumi.getter(name="mongodbVersion")
    def mongodb_version(self) -> pulumi.Output[str]:
        """
        [string] The MongoDB version of your cluster. Updates to the value of the field force the cluster to be re-created.
        """
        return pulumi.get(self, "mongodb_version")

    @property
    @pulumi.getter
    def ram(self) -> pulumi.Output[int]:
        """
        (Computed)[int]The amount of memory per instance in megabytes. Required for enterprise edition.
        """
        return pulumi.get(self, "ram")

    @property
    @pulumi.getter
    def shards(self) -> pulumi.Output[Optional[int]]:
        """
        [int]The total number of shards in the cluster.
        """
        return pulumi.get(self, "shards")

    @property
    @pulumi.getter(name="storageSize")
    def storage_size(self) -> pulumi.Output[int]:
        """
        (Computed)[int] The amount of storage per instance in MB. Required for enterprise edition.
        """
        return pulumi.get(self, "storage_size")

    @property
    @pulumi.getter(name="storageType")
    def storage_type(self) -> pulumi.Output[str]:
        """
        (Computed)[String] The storage type used in your cluster. Required for enterprise edition.
        """
        return pulumi.get(self, "storage_type")

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> pulumi.Output[Optional[str]]:
        """
        [string] The unique ID of the template, which specifies the number of cores, storage size, and memory. Updates to the value of the field force the cluster to be re-created. Required for playground and business editions. Must not be provided for enterprise edition.
        """
        return pulumi.get(self, "template_id")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        (Computed)[string]The cluster type, either `replicaset` or `sharded-cluster`.
        """
        return pulumi.get(self, "type")

