# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = ['TopicArgs', 'Topic']

@pulumi.input_type
class TopicArgs:
    def __init__(__self__, *,
                 cluster_id: pulumi.Input[str],
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 number_of_partitions: Optional[pulumi.Input[int]] = None,
                 replication_factor: Optional[pulumi.Input[int]] = None,
                 retention_time: Optional[pulumi.Input[int]] = None,
                 segment_bytes: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a Topic resource.
        :param pulumi.Input[str] cluster_id: [string] ID of the Kafka Cluster that the topic belongs to.
        :param pulumi.Input[str] location: [string] The location of the Kafka Cluster Topic. Possible values: `de/fra`, `de/txl`. If this is not set and if no value is provided for the `IONOS_API_URL` env var, the default `location` will be: `de/fra`.
        :param pulumi.Input[str] name: [string] Name of the Kafka Cluster.
        :param pulumi.Input[int] number_of_partitions: [int] The number of partitions of the topic. Partitions allow for parallel
               processing of messages. The partition count must be greater than or equal to the replication factor. Minimum value: 1.
               Default value: 3.
        :param pulumi.Input[int] replication_factor: [int] The number of replicas of the topic. The replication factor determines how many
               copies of the topic are stored on different brokers. The replication factor must be less than or equal to the number
               of brokers in the Kafka Cluster. Minimum value: 1. Default value: 3.
        :param pulumi.Input[int] retention_time: [int] This configuration controls the maximum time we will retain a log before we will
               discard old log segments to free up space. This represents an SLA on how soon consumers must read their data. If set
               to -1, no time limit is applied. Default value: 604800000.
        :param pulumi.Input[int] segment_bytes: [int] This configuration controls the segment file size for the log. Retention and
               cleaning is always done a file at a time so a larger segment size means fewer files but less granular control over
               retention. Default value: 1073741824.
        """
        pulumi.set(__self__, "cluster_id", cluster_id)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if number_of_partitions is not None:
            pulumi.set(__self__, "number_of_partitions", number_of_partitions)
        if replication_factor is not None:
            pulumi.set(__self__, "replication_factor", replication_factor)
        if retention_time is not None:
            pulumi.set(__self__, "retention_time", retention_time)
        if segment_bytes is not None:
            pulumi.set(__self__, "segment_bytes", segment_bytes)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Input[str]:
        """
        [string] ID of the Kafka Cluster that the topic belongs to.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The location of the Kafka Cluster Topic. Possible values: `de/fra`, `de/txl`. If this is not set and if no value is provided for the `IONOS_API_URL` env var, the default `location` will be: `de/fra`.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] Name of the Kafka Cluster.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="numberOfPartitions")
    def number_of_partitions(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The number of partitions of the topic. Partitions allow for parallel
        processing of messages. The partition count must be greater than or equal to the replication factor. Minimum value: 1.
        Default value: 3.
        """
        return pulumi.get(self, "number_of_partitions")

    @number_of_partitions.setter
    def number_of_partitions(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "number_of_partitions", value)

    @property
    @pulumi.getter(name="replicationFactor")
    def replication_factor(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The number of replicas of the topic. The replication factor determines how many
        copies of the topic are stored on different brokers. The replication factor must be less than or equal to the number
        of brokers in the Kafka Cluster. Minimum value: 1. Default value: 3.
        """
        return pulumi.get(self, "replication_factor")

    @replication_factor.setter
    def replication_factor(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "replication_factor", value)

    @property
    @pulumi.getter(name="retentionTime")
    def retention_time(self) -> Optional[pulumi.Input[int]]:
        """
        [int] This configuration controls the maximum time we will retain a log before we will
        discard old log segments to free up space. This represents an SLA on how soon consumers must read their data. If set
        to -1, no time limit is applied. Default value: 604800000.
        """
        return pulumi.get(self, "retention_time")

    @retention_time.setter
    def retention_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "retention_time", value)

    @property
    @pulumi.getter(name="segmentBytes")
    def segment_bytes(self) -> Optional[pulumi.Input[int]]:
        """
        [int] This configuration controls the segment file size for the log. Retention and
        cleaning is always done a file at a time so a larger segment size means fewer files but less granular control over
        retention. Default value: 1073741824.
        """
        return pulumi.get(self, "segment_bytes")

    @segment_bytes.setter
    def segment_bytes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "segment_bytes", value)


@pulumi.input_type
class _TopicState:
    def __init__(__self__, *,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 number_of_partitions: Optional[pulumi.Input[int]] = None,
                 replication_factor: Optional[pulumi.Input[int]] = None,
                 retention_time: Optional[pulumi.Input[int]] = None,
                 segment_bytes: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering Topic resources.
        :param pulumi.Input[str] cluster_id: [string] ID of the Kafka Cluster that the topic belongs to.
        :param pulumi.Input[str] location: [string] The location of the Kafka Cluster Topic. Possible values: `de/fra`, `de/txl`. If this is not set and if no value is provided for the `IONOS_API_URL` env var, the default `location` will be: `de/fra`.
        :param pulumi.Input[str] name: [string] Name of the Kafka Cluster.
        :param pulumi.Input[int] number_of_partitions: [int] The number of partitions of the topic. Partitions allow for parallel
               processing of messages. The partition count must be greater than or equal to the replication factor. Minimum value: 1.
               Default value: 3.
        :param pulumi.Input[int] replication_factor: [int] The number of replicas of the topic. The replication factor determines how many
               copies of the topic are stored on different brokers. The replication factor must be less than or equal to the number
               of brokers in the Kafka Cluster. Minimum value: 1. Default value: 3.
        :param pulumi.Input[int] retention_time: [int] This configuration controls the maximum time we will retain a log before we will
               discard old log segments to free up space. This represents an SLA on how soon consumers must read their data. If set
               to -1, no time limit is applied. Default value: 604800000.
        :param pulumi.Input[int] segment_bytes: [int] This configuration controls the segment file size for the log. Retention and
               cleaning is always done a file at a time so a larger segment size means fewer files but less granular control over
               retention. Default value: 1073741824.
        """
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if number_of_partitions is not None:
            pulumi.set(__self__, "number_of_partitions", number_of_partitions)
        if replication_factor is not None:
            pulumi.set(__self__, "replication_factor", replication_factor)
        if retention_time is not None:
            pulumi.set(__self__, "retention_time", retention_time)
        if segment_bytes is not None:
            pulumi.set(__self__, "segment_bytes", segment_bytes)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[pulumi.Input[str]]:
        """
        [string] ID of the Kafka Cluster that the topic belongs to.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        [string] The location of the Kafka Cluster Topic. Possible values: `de/fra`, `de/txl`. If this is not set and if no value is provided for the `IONOS_API_URL` env var, the default `location` will be: `de/fra`.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        [string] Name of the Kafka Cluster.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="numberOfPartitions")
    def number_of_partitions(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The number of partitions of the topic. Partitions allow for parallel
        processing of messages. The partition count must be greater than or equal to the replication factor. Minimum value: 1.
        Default value: 3.
        """
        return pulumi.get(self, "number_of_partitions")

    @number_of_partitions.setter
    def number_of_partitions(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "number_of_partitions", value)

    @property
    @pulumi.getter(name="replicationFactor")
    def replication_factor(self) -> Optional[pulumi.Input[int]]:
        """
        [int] The number of replicas of the topic. The replication factor determines how many
        copies of the topic are stored on different brokers. The replication factor must be less than or equal to the number
        of brokers in the Kafka Cluster. Minimum value: 1. Default value: 3.
        """
        return pulumi.get(self, "replication_factor")

    @replication_factor.setter
    def replication_factor(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "replication_factor", value)

    @property
    @pulumi.getter(name="retentionTime")
    def retention_time(self) -> Optional[pulumi.Input[int]]:
        """
        [int] This configuration controls the maximum time we will retain a log before we will
        discard old log segments to free up space. This represents an SLA on how soon consumers must read their data. If set
        to -1, no time limit is applied. Default value: 604800000.
        """
        return pulumi.get(self, "retention_time")

    @retention_time.setter
    def retention_time(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "retention_time", value)

    @property
    @pulumi.getter(name="segmentBytes")
    def segment_bytes(self) -> Optional[pulumi.Input[int]]:
        """
        [int] This configuration controls the segment file size for the log. Retention and
        cleaning is always done a file at a time so a larger segment size means fewer files but less granular control over
        retention. Default value: 1073741824.
        """
        return pulumi.get(self, "segment_bytes")

    @segment_bytes.setter
    def segment_bytes(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "segment_bytes", value)


class Topic(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 number_of_partitions: Optional[pulumi.Input[int]] = None,
                 replication_factor: Optional[pulumi.Input[int]] = None,
                 retention_time: Optional[pulumi.Input[int]] = None,
                 segment_bytes: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Manages a **Kafka Cluster Topic** on IonosCloud.

        ## Example Usage

        This resource will create an operational Kafka Cluster Topic. After this section completes, the provisioner can be
        called.

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud

        # Basic example
        example = ionoscloud.compute.Datacenter("example",
            name="example-kafka-datacenter",
            location="de/fra")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=False,
            name="example-kafka-lan")
        example_cluster = ionoscloud.kafka.Cluster("example",
            name="example-kafka-cluster",
            location=example.location,
            version="3.7.0",
            size="S",
            connections={
                "datacenter_id": example.id,
                "lan_id": example_lan.id,
                "broker_addresses": [
                    "192.168.1.101/24",
                    "192.168.1.102/24",
                    "192.168.1.103/24",
                ],
            })
        example_topic = ionoscloud.kafka.Topic("example",
            cluster_id=example_cluster.id,
            name="kafka-cluster-topic",
            location=example_cluster.location,
            replication_factor=1,
            number_of_partitions=1,
            retention_time=86400000,
            segment_bytes=1073741824)
        ```

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        # Complete example
        example = ionoscloud.compute.Datacenter("example",
            name="example-kafka-datacenter",
            location="de/fra")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=False,
            name="example-kafka-lan")
        password = random.index.Password("password",
            length=16,
            special=False)
        example_server = ionoscloud.compute.Server("example",
            name="example-kafka-server",
            datacenter_id=example.id,
            cores=1,
            ram=2 * 1024,
            availability_zone="AUTO",
            cpu_family="INTEL_SKYLAKE",
            image_name="ubuntu:latest",
            image_password=password["result"],
            volume={
                "name": "example-kafka-volume",
                "size": 6,
                "disk_type": "SSD Standard",
            },
            nic={
                "lan": example_lan.id,
                "name": "example-kafka-nic",
                "dhcp": True,
            })
        example_cluster = ionoscloud.kafka.Cluster("example",
            name="example-kafka-cluster",
            location=example.location,
            version="3.7.0",
            size="S",
            connections={
                "datacenter_id": example.id,
                "lan_id": example_lan.id,
                "broker_addresses": "kafka_cluster_broker_ips_cidr_list",
            })
        example_topic = ionoscloud.kafka.Topic("example",
            cluster_id=example_cluster.id,
            name="kafka-cluster-topic",
            location=example_cluster.location,
            replication_factor=1,
            number_of_partitions=1,
            retention_time=86400000,
            segment_bytes=1073741824)
        ```

        ## Import

        Kafka Cluster Topic can be imported using the `location`, `kafka cluster id` and the `kafka cluster topic id`:

        ```sh
        $ pulumi import ionoscloud:kafka/topic:Topic my_topic location:kafka cluster uuid:kafka cluster topic uuid
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: [string] ID of the Kafka Cluster that the topic belongs to.
        :param pulumi.Input[str] location: [string] The location of the Kafka Cluster Topic. Possible values: `de/fra`, `de/txl`. If this is not set and if no value is provided for the `IONOS_API_URL` env var, the default `location` will be: `de/fra`.
        :param pulumi.Input[str] name: [string] Name of the Kafka Cluster.
        :param pulumi.Input[int] number_of_partitions: [int] The number of partitions of the topic. Partitions allow for parallel
               processing of messages. The partition count must be greater than or equal to the replication factor. Minimum value: 1.
               Default value: 3.
        :param pulumi.Input[int] replication_factor: [int] The number of replicas of the topic. The replication factor determines how many
               copies of the topic are stored on different brokers. The replication factor must be less than or equal to the number
               of brokers in the Kafka Cluster. Minimum value: 1. Default value: 3.
        :param pulumi.Input[int] retention_time: [int] This configuration controls the maximum time we will retain a log before we will
               discard old log segments to free up space. This represents an SLA on how soon consumers must read their data. If set
               to -1, no time limit is applied. Default value: 604800000.
        :param pulumi.Input[int] segment_bytes: [int] This configuration controls the segment file size for the log. Retention and
               cleaning is always done a file at a time so a larger segment size means fewer files but less granular control over
               retention. Default value: 1073741824.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TopicArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages a **Kafka Cluster Topic** on IonosCloud.

        ## Example Usage

        This resource will create an operational Kafka Cluster Topic. After this section completes, the provisioner can be
        called.

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud

        # Basic example
        example = ionoscloud.compute.Datacenter("example",
            name="example-kafka-datacenter",
            location="de/fra")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=False,
            name="example-kafka-lan")
        example_cluster = ionoscloud.kafka.Cluster("example",
            name="example-kafka-cluster",
            location=example.location,
            version="3.7.0",
            size="S",
            connections={
                "datacenter_id": example.id,
                "lan_id": example_lan.id,
                "broker_addresses": [
                    "192.168.1.101/24",
                    "192.168.1.102/24",
                    "192.168.1.103/24",
                ],
            })
        example_topic = ionoscloud.kafka.Topic("example",
            cluster_id=example_cluster.id,
            name="kafka-cluster-topic",
            location=example_cluster.location,
            replication_factor=1,
            number_of_partitions=1,
            retention_time=86400000,
            segment_bytes=1073741824)
        ```

        ```python
        import pulumi
        import pulumi_ionoscloud as ionoscloud
        import pulumi_random as random

        # Complete example
        example = ionoscloud.compute.Datacenter("example",
            name="example-kafka-datacenter",
            location="de/fra")
        example_lan = ionoscloud.compute.Lan("example",
            datacenter_id=example.id,
            public=False,
            name="example-kafka-lan")
        password = random.index.Password("password",
            length=16,
            special=False)
        example_server = ionoscloud.compute.Server("example",
            name="example-kafka-server",
            datacenter_id=example.id,
            cores=1,
            ram=2 * 1024,
            availability_zone="AUTO",
            cpu_family="INTEL_SKYLAKE",
            image_name="ubuntu:latest",
            image_password=password["result"],
            volume={
                "name": "example-kafka-volume",
                "size": 6,
                "disk_type": "SSD Standard",
            },
            nic={
                "lan": example_lan.id,
                "name": "example-kafka-nic",
                "dhcp": True,
            })
        example_cluster = ionoscloud.kafka.Cluster("example",
            name="example-kafka-cluster",
            location=example.location,
            version="3.7.0",
            size="S",
            connections={
                "datacenter_id": example.id,
                "lan_id": example_lan.id,
                "broker_addresses": "kafka_cluster_broker_ips_cidr_list",
            })
        example_topic = ionoscloud.kafka.Topic("example",
            cluster_id=example_cluster.id,
            name="kafka-cluster-topic",
            location=example_cluster.location,
            replication_factor=1,
            number_of_partitions=1,
            retention_time=86400000,
            segment_bytes=1073741824)
        ```

        ## Import

        Kafka Cluster Topic can be imported using the `location`, `kafka cluster id` and the `kafka cluster topic id`:

        ```sh
        $ pulumi import ionoscloud:kafka/topic:Topic my_topic location:kafka cluster uuid:kafka cluster topic uuid
        ```

        :param str resource_name: The name of the resource.
        :param TopicArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TopicArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 number_of_partitions: Optional[pulumi.Input[int]] = None,
                 replication_factor: Optional[pulumi.Input[int]] = None,
                 retention_time: Optional[pulumi.Input[int]] = None,
                 segment_bytes: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TopicArgs.__new__(TopicArgs)

            if cluster_id is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_id'")
            __props__.__dict__["cluster_id"] = cluster_id
            __props__.__dict__["location"] = location
            __props__.__dict__["name"] = name
            __props__.__dict__["number_of_partitions"] = number_of_partitions
            __props__.__dict__["replication_factor"] = replication_factor
            __props__.__dict__["retention_time"] = retention_time
            __props__.__dict__["segment_bytes"] = segment_bytes
        super(Topic, __self__).__init__(
            'ionoscloud:kafka/topic:Topic',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cluster_id: Optional[pulumi.Input[str]] = None,
            location: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            number_of_partitions: Optional[pulumi.Input[int]] = None,
            replication_factor: Optional[pulumi.Input[int]] = None,
            retention_time: Optional[pulumi.Input[int]] = None,
            segment_bytes: Optional[pulumi.Input[int]] = None) -> 'Topic':
        """
        Get an existing Topic resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: [string] ID of the Kafka Cluster that the topic belongs to.
        :param pulumi.Input[str] location: [string] The location of the Kafka Cluster Topic. Possible values: `de/fra`, `de/txl`. If this is not set and if no value is provided for the `IONOS_API_URL` env var, the default `location` will be: `de/fra`.
        :param pulumi.Input[str] name: [string] Name of the Kafka Cluster.
        :param pulumi.Input[int] number_of_partitions: [int] The number of partitions of the topic. Partitions allow for parallel
               processing of messages. The partition count must be greater than or equal to the replication factor. Minimum value: 1.
               Default value: 3.
        :param pulumi.Input[int] replication_factor: [int] The number of replicas of the topic. The replication factor determines how many
               copies of the topic are stored on different brokers. The replication factor must be less than or equal to the number
               of brokers in the Kafka Cluster. Minimum value: 1. Default value: 3.
        :param pulumi.Input[int] retention_time: [int] This configuration controls the maximum time we will retain a log before we will
               discard old log segments to free up space. This represents an SLA on how soon consumers must read their data. If set
               to -1, no time limit is applied. Default value: 604800000.
        :param pulumi.Input[int] segment_bytes: [int] This configuration controls the segment file size for the log. Retention and
               cleaning is always done a file at a time so a larger segment size means fewer files but less granular control over
               retention. Default value: 1073741824.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TopicState.__new__(_TopicState)

        __props__.__dict__["cluster_id"] = cluster_id
        __props__.__dict__["location"] = location
        __props__.__dict__["name"] = name
        __props__.__dict__["number_of_partitions"] = number_of_partitions
        __props__.__dict__["replication_factor"] = replication_factor
        __props__.__dict__["retention_time"] = retention_time
        __props__.__dict__["segment_bytes"] = segment_bytes
        return Topic(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Output[str]:
        """
        [string] ID of the Kafka Cluster that the topic belongs to.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[Optional[str]]:
        """
        [string] The location of the Kafka Cluster Topic. Possible values: `de/fra`, `de/txl`. If this is not set and if no value is provided for the `IONOS_API_URL` env var, the default `location` will be: `de/fra`.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        [string] Name of the Kafka Cluster.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="numberOfPartitions")
    def number_of_partitions(self) -> pulumi.Output[Optional[int]]:
        """
        [int] The number of partitions of the topic. Partitions allow for parallel
        processing of messages. The partition count must be greater than or equal to the replication factor. Minimum value: 1.
        Default value: 3.
        """
        return pulumi.get(self, "number_of_partitions")

    @property
    @pulumi.getter(name="replicationFactor")
    def replication_factor(self) -> pulumi.Output[Optional[int]]:
        """
        [int] The number of replicas of the topic. The replication factor determines how many
        copies of the topic are stored on different brokers. The replication factor must be less than or equal to the number
        of brokers in the Kafka Cluster. Minimum value: 1. Default value: 3.
        """
        return pulumi.get(self, "replication_factor")

    @property
    @pulumi.getter(name="retentionTime")
    def retention_time(self) -> pulumi.Output[Optional[int]]:
        """
        [int] This configuration controls the maximum time we will retain a log before we will
        discard old log segments to free up space. This represents an SLA on how soon consumers must read their data. If set
        to -1, no time limit is applied. Default value: 604800000.
        """
        return pulumi.get(self, "retention_time")

    @property
    @pulumi.getter(name="segmentBytes")
    def segment_bytes(self) -> pulumi.Output[Optional[int]]:
        """
        [int] This configuration controls the segment file size for the log. Retention and
        cleaning is always done a file at a time so a larger segment size means fewer files but less granular control over
        retention. Default value: 1073741824.
        """
        return pulumi.get(self, "segment_bytes")

